
;	.include "m644padef.inc"
	.include "m1284pdef.inc"

;setting test to 1 shortens the full speed trace length to only a few dozen bytes to reduce time needed for assembly and device programming
.equ	test=0

;set debug to 1 and use the following calls
; call dumpregs		to dump register contents over serial line

; ldi YL,LOW(addr)
; ldi YH,HIGH(addr)
; ldi r17,length
; call dump_hexs	to dump data memory contents over serial line
.equ	debug=0


;PB7		LCD /WR
;PB6		LCD /RD
;PB5		LCD C/D, middle button
;PB4 		/Key Scan Select
;PB3/OC0A	LCD contrast voltage PWM
;PB2		LCD /Reset
;PB1		Tx
;PB0		Rx

;PD0-7		LCD D0-D7

;PD6+7		right encoder
;PD4+5		left encoder
;PD3		right button
;PD2		left button
;PD1		left encoder switch
;PD0		right encoder switch

.equ middle_bttn=4
.equ right_bttn=3
.equ left_bttn=2
.equ left_enc_sw=1
.equ right_enc_sw=0


	#ifdef _M1284PDEF_INC_
	.equ trace_size=15000
	#endif

	#ifdef _M644PADEF_INC_
	.equ trace_size=3500
	#endif

.equ blsize=256
.equ tr_mode=GPIOR0
;Bit 0		0=pretrig, 1=posttrig
;Bit 1		0=8 inputs, 1=16 inputs
;Bit 6		0=no changes, 1=parameter has been changed
;Bit 7		0=show features, 1=show single line

.equ text_scr=0
.equ alt_scr=$100
.equ graphic_scr=$200

.equ prefsize=32		;reserved for each preference entry
.equ prefsize1=21		;actually used for preference entry
.equ dprefs=16			;number of default preference entries to have a simple kind of EEPROM wear leveling (about 1.6 million preference write cycles)

.equ ser_speed=57600 ;9600 

	.org 0
	rjmp init

	.org INT0addr
	reti

	.org INT1addr
	cli
	rjmp trbreak

	.org INT2addr
	reti

	.org PCI0addr
	in r0,PINA
	in r3,PINC
	jmp trc_post_trig

sfact:	.dw $ccd,$199a,$3334,$8000

time_div: .db 64,26,13,7

	.org OC2Aaddr
systimer:
	push r16
	in r16,SREG
	cli
	push r16
	push r17
	ldi r16,-1
	out PORTD,r16
	clr r16
	out DDRD,r16
	sbi PORTB,PB5
	cbi DDRB,PB5
	cbi PORTB,PB4
	rjmp PC+1
	in r16,PIND
	in r17,PINB
	sbi PORTB,PB4
	sbi DDRB,PB5
	sts kstate1,r17
	lds r17,kstate
	cp r16,r17
	breq systimerx
	sts kstate,r16
	
	push YL
	push YH
	push ZL
	push ZH

	swap r16
	push r16
	ldi YL,LOW(cnstate1)
	ldi YH,HIGH(cnstate1)
	rcall eval_enc
	pop r16
	lsr r16
	lsr r16
	rcall eval_enc	

	pop ZH
	pop ZL
	pop YH
	pop YL
systimerx:
	lds r16,kstate
	com r16
	andi r16,15
	lds r17,kstate1
	lsr r17
	com r17
	andi r17,$10
	or r16,r17
	lds r17,keys
	cp r16,r17
	breq systimerx1
	lds r17,tkeys
	cp r16,r17
	lds r17,dbnce
	breq systimerk1
	sts tkeys,r16
	ldi r17,100
systimerk1: dec r17
	brne systimerkx
	sts keys,r16
systimerkx: sts dbnce,r17
systimerx1:
	pop r17
	pop r16
	out SREG,r16
	pop r16
	reti

eval_enc: andi r16,3
	ld r17,Y
 	lsl r17
 	lsl r17
 	or r17,r16
	andi r17,15
	st Y+,r17
	ldi ZL,LOW(dgtab*2)
	ldi ZH,HIGH(dgtab*2)
	add ZL,r17
	ldi r17,0
	adc ZH,r17
	lpm r17,Z
	ld r16,Y
	add r16,r17
	st Y+,r16
	ret

trbreak: ldi r16,1<<right_bttn
	sts keys,r16
	sbic tr_mode,0
	jmp trc_post_end
	pop r16
	pop r16
	jmp trc_end

;almost all defined data has been put here to avoid the need of extended address handling

pic:	.db 3,"PIC",6,".PBM",0,0			,-1 ;filler
dmp:	.db 5,"TRACE",6,".DMP",0,0			,-1 ;filler
pichdr: .db 12,"P4",13,10,"128 128 "		,-1 ;filler
zend:	.db 2,"OO"							,-1 ;filler

;the following strings have a CRC16 checksum attached
;if you change something remember to recalculate the CRC16 value using the XMODEM CRC setting (you can do it online, there are various sites on the web)
;Example:
;EOF header for Trace Dump file length 3500=0x0dac bytes
;calculate CRC for "0bac0d0000", append the value as four ASCII chars - "0bac0d00000bea"
zrqinit: .db 21,"rz",13,"**",$18,"B00000000000000"
zfile:	.db 11,"**",$18,'A',4,0,0,4,1,$55,$e3
zdata:	.db 11,"**",$18,'A',10,0,0,0,0,$46,$ae
zeofpic: .db 22,$18,$68,$ed,$ae,"**",$18,"B0b0c0800000a6c"		,-1 ;filler
	.if trace_size==3500	
zeofdmp: .db 22,$18,$68,$ed,$ae,"**",$18,"B0bac0d00000bea"		,-1 ;filler
	.endif
	.if trace_size==15000	
zeofdmp: .db 22,$18,$68,$ed,$ae,"**",$18,"B0b983a0000adc7"		,-1 ;filler
	.endif
zfin:	.db 18,"**",$18,"B0800000000022d"	,-1 ;filler

sending_tx: .db 4*16+4,"Sending",0			,-1 ;filler
screenshot_tx: .db 5*16+3,"Screenshot",0
trcdmp_tx:	.db 5*16+3,"Tracedump",0		,-1 ;filler

		.db -20,-10,-5,-2
scaletab: .db 1,2,5,10,20			,-1 //filler

encsc: .db 1,2,5,10,20,50,75,100
	   .db 1,2,3,4,5,10,20,50
	   .db 1,2,3,4,5,10,15,20
	   .db 1,2,3,4,5,10,15,20
	   .db 1,2,3,4,5,6,10,12

;table with incrementer values (indexed with old-old-new-new bits)
dgtab:
.db     0, 1
.db     0, 0
.db    -1, 0
.db     0, 0
.db     0, 0
.db     0,-1
.db     0, 0
.db     1, 0

lcd_init_str:
		.db 1,$9c										;text & graphic on
		.db 1,$80										;OR mode, text and graphic pixels are "ored" together
		.db 3,16,0,$41									;set text area, 16 colums per line
		.db 3,LOW(text_scr),HIGH(text_scr),$40			;set text home address
		.db 3,16,0,$43									;set graphic area
		.db 3,LOW(graphic_scr),HIGH(graphic_scr),$42	;set graphic home address
		.db 3,2,0,$22									;set offset register for CGRAM (starting at $1000)
		.db 3,0,$14,$24									;set address pointer for CGRAM
		.db 1,$b0										;auto write
		.db 0		,-1 //filler

;menu structure
;b		object count
;b		row or -1 for end
;b		column
;string	description
;b		0 string terminator
;b		object index

.equ menu3_base=8

menu1:	.db 7,0,4,"Settings",0,0,2,0,"Trigger",0,0,3,0,"Input: ABCDEFGH",0,0,4,0,"Cndtn: ",0,1,5,1,"Mode: ",0,2,7,1,"SClk: ",0,3,8,0,"Lines: ",0,4,10,0,"Pref#: ",0,5,11,1,"Actn: ",0,6,13,2,"LCD: ",0,7,-1
menu2:	.db 0,1,0,"Recording active",0,0,3,3,"Press Stop",0,0,4,3,"for abort.",0,0,-1
menu3:	.db 16,0,0,"A: ",0,8,1,0,"B: ",0,9,2,0,"C: ",0,10,3,0,"D: ",0,11,4,0,"E: ",0,12
		.db 5,0,"F: ",0,13,6,0,"G: ",0,14,7,0,"H: ",0,15,8,0,"I: ",0,16
		.db 9,0,"J: ",0,17,10,0,"K: ",0,18,11,0,"L: ",0,19,12,0,"M: ",0,20
		.db 13,0,"N: ",0,21,14,0,"O: ",0,22,15,0,"P: ",0,23,-1
menu_actions: .dw show_trig,show_mode,show_sclk,show_lines,show_prefno,show_pact,show_lcd_pwm
		.dw show_ln		;show_ln must be the last action and is explicitely handled
menu_actions1: .dw ch_trig,ch_mode,ch_sclk,ch_lines,ch_prefno,ch_pact,ch_lcd_pwm
		.dw ch_ln		;ch_ln must be the last action and is explicitely handled	

.equ trigger_obj_no=1
.equ prefs_obj_no=6
.equ line_obj_no=8

menu_oblen: .db -8,8,6,2,1,4,8,11	;entry for line mode must be the last one and is explicitely handled

;serial line modes are explicitely handled
menu3_len: .db 0,2,1,2,2,2,2		,-1	;filler

;serial line modes are explicitely handled
ln_p:	.db 0,1,2,3,3,3,3			,-1 ;filler
ln_p1:	.db 0,0,2,0,0,0,0			,-1 ;filler
ln_p2:	.db 0,1,0,3,3,3,3			,-1 ;filler

ln_modx: .db "SL         ",0
		.db "Nibble ",0
		.db "I2C (",0
		.db "SPI ",$86+32,$87+32,$84+32,0
		.db "SPI ",$86+32,$87+32,$85+32,0
		.db "SPI ",$88+32,$89+32,$84+32,0
		.db "SPI ",$88+32,$89+32,$85+32,0
		.db "Serial 8n1",0,"Serial 8p1",0,"Serial 7n1",0,"Serial 7p1",0,"Serial 6n1",0,"Serial 6p1",0,"Serial 5n1",0,"Serial 5p1",0,"InvSer 8n1",0,"InvSer 8p1",0,"InvSer 7n1",0,"InvSer 7p1",0,"InvSer 6n1",0,"InvSer 6p1",0,"InvSer 5n1",0,"InvSer 5p1",0

.equ ser_modes=7

nib_tx:	.db "A-D",0,"E-H",0,"I-L",0,"M-P",0
i2c_tx: .db "SDA)  ",0,"SCL)  ",0
spi_tx:	.db "MOSI",0,"MISO",0,"SCLK",0,"/SS ",0

lnt:	.dw lnt1*2,lnt3*2,lnt2*2,lnt3*2,lnt1*2,lnt3*2,lnt2*2,lnt3*2,lnt1*2,lnt3*2,lnt2*2,lnt3*2,lnt1*2,lnt3*2,lnt2*2,lnt3*2
lnt1:	.db 0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,-1
lnt2:	.db 0,2,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,-1			,-1 //filler
lnt3:	.db 0,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,-1

mode_pretx: .db "Pretrig ",0		,-1 //filler
mode_posttx: .db "Posttrig",0		,-1 //filler
prefa_tx:	.db "Load",0,"Save",0

mode_sclki:	.db $11,$10,'M'+96,$12,'M'+96,$11,'M'+96,$15,$10,$10,'k'+96,$12,$10,$10,'k'+96,$11,$10,$10,'k'+96,$15,$10,'k'+96
			.db $12,$10,'k'+96,$11,$10,'k'+96,$15,'k'+96
			.db $12,'k'+96,$11,'k'+96
			.db $15,$10,$10+128,$12,$10,$10+128
			.db $11,$10,$10+128,$15,$10+128,$12,$10+128,$11,$10+128,$15+128,$12+128,$15,'M'+96		,-1 //filler
mode_sclk: .db 0,3,5,7,11,15,19,22,25,28,30,32,34,37,40,43,45,47,49,50,51							,-1 //filler
hz_tx: .db "Hz  ",0				,-1 //filler

mode_tms:
	.db 0b00010101,0b00010101	;0.1us, 0.5us
	.db 0b01010101,0b01010101	;1us, 2us
	.db 0b01010101,0b01010101	;5us, 10us
	.db 0b01010101,0b01010101	;20us, 50us
	.db 0b01011010,0b01101010	;100us, 200us
	.db 0b01101010,0b10101010	;500us, 1ms
	.db 0b10101010,0b10101010	;2ms, 5ms
	.db 0b10101010,0b10101010	;10ms, 20ms
	.db 0b10101010,0b10101111	;50ms, 100ms
	.db 0b10111111,0b10111111	;200ms, 500ms
	.db 0b00010101	      ,-1   ;0.2us

mode_tmsi: .db 'n'-32,'s'-32,$80,'s'-32,'m'-32,'s'-32,'s'-32,0

mode_tm: .db $80,'s'-32
		.db $80,'s'-32
		.db $80,'s'-32
		.db $80,'s'-32
		.db $80,'s'-32
		.db 'm'-32,'s'-32
		.db 'm'-32,'s'-32
		.db 'm'-32,'s'-32
		.db 'm'-32,'s'-32
		.db 'm'-32,'s'-32
		.db 'm'-32,'s'-32
		.db 'm'-32,'s'-32
		.db 'm'-32,'s'-32
		.db 'm'-32,'s'-32
		.db 's'-32,0
		.db 's'-32,0
		.db 's'-32,0
		.db 's'-32,0
		.db 's'-32,0
		.db 's'-32,0

scaletxi:
		.db 0,'5'-32,'0'-32,'n'-32			;0
		.db '1'-32,'0'-32,'0'-32,'n'-32		;1
		.db '2'-32,'0'-32,'0'-32,'n'-32		;2
		.db '2'-32,'5'-32,'0'-32,'n'-32		;3
		.db '4'-32,'0'-32,'0'-32,'n'-32		;4
		.db '5'-32,'0'-32,'0'-32,'n'-32		;5
		.db 0,0,'1'-32,$80					;6
		.db 0,0,'2'-32,$80					;7
		.db '2'-32,'.'-32,'5'-32,$80		;8
		.db 0,0,'4'-32,$80					;9
		.db 0,0,'5'-32,$80					;10
		.db 0,'1'-32,'0'-32,$80				;11
		.db 0,'2'-32,'0'-32,$80				;12
		.db 0,'2'-32,'5'-32,$80				;13
		.db 0,'4'-32,'0'-32,$80				;14
		.db 0,'5'-32,'0'-32,$80				;15
		.db '1'-32,'0'-32,'0'-32,$80		;16
		.db '2'-32,'0'-32,'0'-32,$80		;17
		.db '2'-32,'5'-32,'0'-32,$80		;18
		.db '4'-32,'0'-32,'0'-32,$80		;19
		.db '5'-32,'0'-32,'0'-32,$80		;20
		.db 0,0,'1'-32,'m'-32				;21
		.db 0,0,'2'-32,'m'-32				;22
		.db '2'-32,'.'-32,'5'-32,'m'-32		;23
		.db 0,0,'4'-32,'m'-32				;24
		.db 0,0,'5'-32,'m'-32				;25
		.db 0,'1'-32,'0'-32,'m'-32			;26
		.db 0,'2'-32,'0'-32,'m'-32			;27
		.db 0,'2'-32,'5'-32,'m'-32			;28
		.db 0,'4'-32,'0'-32,'m'-32			;29
		.db 0,'5'-32,'0'-32,'m'-32			;30
		.db '1'-32,'0'-32,'0'-32,'m'-32		;31
		.db '2'-32,'0'-32,'0'-32,'m'-32		;32
		.db '2'-32,'5'-32,'0'-32,'m'-32		;33
		.db '4'-32,'0'-32,'0'-32,'m'-32		;34
		.db '5'-32,'0'-32,'0'-32,'m'-32		;35
		.db 0,0,0,'1'-32					;36
		.db 0,0,0,'2'-32					;37
		.db 0,'2'-32,'.'-32,'5'-32			;38
		.db 0,0,0,'4'-32					;39
		.db 0,0,0,'5'-32					;40
		.db 0,0,'1'-32,'0'-32				;41
		.db 0,0,'2'-32,'0'-32				;42
		.db 0,0,'4'-32,'0'-32				;43
		.db 0,0,'5'-32,'0'-32				;44
		.db 0,'1'-32,'0'-32,'0'-32			;45


		.db 0,1,2,5
scaletx:
;0.1us, 0.5us
		.db 6,7,10,11,12,3,5,6,8,10,11,13,15,16
		.db 5,6,7,10
;1us, 2us
		.db 11,12,15,16,17,6,7,9,11,12,14,16,17,19
		.db 8,10,11,13
;5us, 10us
		.db 15,16,18,20,21,10,11,12,15,16,17,20,21,22
		.db 11,12,13,16
;20us, 50us
		.db 17,19,21,22,24,13,15,16,18,20,21,23,25,26
		.db 15,16,17,20
;100us, 200us
		.db 21,22,25,26,27,16,17,19,21,22,24,26,27,29
		.db 18,20,21,23
;500us, 1ms
		.db 25,26,28,30,31,20,21,22,25,26,27,30,31,32
		.db 21,22,24,26
;2ms, 5ms
		.db 27,29,31,32,34,23,25,26,28,30,31,33,35,36
		.db 25,26,28,30
;10ms, 20ms
		.db 31,32,35,36,37,26,27,29,31,32,34,36,37,39
		.db 28,30,31,33
;50ms, 100ms
		.db 35,36,38,40,41,30,31,33,35,36,37,40,41,42
		.db 31,32,34,36
;200ms, 500ms
		.db 37,39,41,42,43,32,35,36,38,40,41,42,44,45
		.db 1,2,4,6
;0.2us
		.db 7,9,11,12,14			,-1; filler


chartab: .db 0b00000000,0b00000000,0b00010010,0b00010010,0b00010010,0b00010010,0b00011100,0b00100000
		.db 0b00000000,0b00010111,0b00010100,0b00100100,0b00100100,0b01000100,0b01000111,0b00000000
		.db 0b00000001,0b00000001,0b10100001,0b10000001,0b10101011,0b10101011,0b00100101,0b00000001
		.db 0b00000000,0b00000100,0b00001010,0b00001010,0b00010001,0b00010001,0b00011111,0b00000000
		.db 0b00001110,0b00001000,0b00001000,0b00001000,0b00001000,0b00001000,0b00111000,0b00000000
		.db 0b00111000,0b00001000,0b00001000,0b00001000,0b00001000,0b00001000,0b00001110,0b00000000
		.db 0b10001001,0b11011010,0b10101010,0b10101001,0b10001000,0b10001010,0b10001001,0b00000000
		.db 0b11011110,0b00101001,0b00001001,0b11001110,0b00101001,0b00101001,0b11011110,0b00000000
		.db 0b10000001,0b10000010,0b10000010,0b10000001,0b10000000,0b10000010,0b11111001,0b00000000
		.db 0b11011110,0b00101001,0b00001001,0b11001110,0b00101001,0b00101001,0b11011110,0b00000000
/*
00000000 00000000
00010111 00000000
00010100 10100000
00100100 10000001
00100100 10101010
01000100 10101010
01000111 00100100
00000000 00000000
*/
/*
0b01000000
0b01000100
0b01001010
0b01001010
0b01010001
0b01010001
0b01011111
0b01000000
*/
/*
00001110
00001000
00001000
00001000
00001000
00001000
00111000
00000000

00111000
00001000
00001000
00001000
00001000
00001000
00001110
00000000
*/
/*
1000100111011110
1101101000101001
1010101000001001
1010100111001110
1000100000101001
1000101000101001
1000100111011110
0000000000000000

1000000111011110
1000001000101001
1000001000001001
1000000111001110
1000000000101001
1000001000101001
1111100111011110
0000000000000000

*/
/*
.
00000000
00000000
00000000
00000000
00000000
00001100
00001100
00000000

m
00000000
00000000
00011010
00010101
00010101
00010101
00010101
00000000

n
00000000
00000000
00010110
00011001
00010001
00010001
00010001
00000000

s
00000000
00000000
00001111
00010000
00011110
00000001
00011110
00000000
*/
sschr:
	.db 0,0,0,0,0,0,0,0
	.db 0b00000000,0b00000000,0b00000000,0b00000000,0b00000000,0b00001100,0b00001100,0b00000000
	.db 0b00000000,0b00000000,0b00011010,0b00010101,0b00010101,0b00010101,0b00010101,0b00000000
	.db 0b00000000,0b00000000,0b00010110,0b00011001,0b00010001,0b00010001,0b00010001,0b00000000
	.db 0b00000000,0b00000000,0b00001111,0b00010000,0b00011110,0b00000001,0b00011110,0b00000000

gchar:
	.db 0b00111000,0b01000100,0b01001100,0b01010100,0b01100100,0b01000100,0b00111000,0b00010000,0b00110000,0b00010000,0b00010000,0b00010000,0b00010000,0b00111000
	.db 0b00111000,0b01000100,0b00000100,0b00001000,0b00010000,0b00100000,0b01111100,0b01111100,0b00001000,0b00010000,0b00001000,0b00000100,0b01000100,0b00111000
	.db 0b00001000,0b00011000,0b00101000,0b01001000,0b01111100,0b00001000,0b00001000,0b01111100,0b01000000,0b01111000,0b00000100,0b00000100,0b01000100,0b00111000
	.db 0b00011000,0b00100000,0b01000000,0b01111000,0b01000100,0b01000100,0b00111000,0b01111100,0b00000100,0b00001000,0b00010000,0b00010000,0b00010000,0b00010000
	.db 0b00111000,0b01000100,0b01000100,0b00111000,0b01000100,0b01000100,0b00111000,0b00111000,0b01000100,0b01000100,0b00111100,0b00000100,0b00001000,0b00110000
	.db 0b00111000,0b01000100,0b01000100,0b01000100,0b01111100,0b01000100,0b01000100,0b01111000,0b00100100,0b00100100,0b00111000,0b00100100,0b00100100,0b01111000
	.db 0b00111000,0b01000100,0b01000000,0b01000000,0b01000000,0b01000100,0b00111000,0b01111000,0b00100100,0b00100100,0b00100100,0b00100100,0b00100100,0b01111000
	.db 0b01111100,0b01000000,0b01000000,0b01111000,0b01000000,0b01000000,0b01111100,0b01111100,0b01000000,0b01000000,0b01111000,0b01000000,0b01000000,0b01000000

gcharb:
	.db 0b00010000,0b00100000,0b00100000,0b01000000,0b10000000,0b01000000,0b00100000,0b00100000,0b00010000,0b10000000,0b01000000,0b01000000,0b00100000,0b00010000,0b00100000,0b01000000,0b01000000,0b10000000
	.db 0b10000000,0b00000000,0b00000000,0b00000000,0b00000000,0b00000000,0b00000000,0b00000000,0b10000000,0b10000000,0b10000000,0b10000000,0b10000000,0b10000000,0b10000000,0b10000000,0b10000000,0b10000000
	.db 0b11000000,0b11000000,0b11000000,0b11000000,0b11000000,0b11000000,0b11000000,0b11000000,0b11000000,0b01000000,0b01000000,0b10100000,0b10100000,0b10100000,0b10100000,0b10100000,0b01000000,0b01000000
	.db 0b01100000,0b01100000,0b10010000,0b10010000,0b10010000,0b10010000,0b10010000,0b01100000,0b01100000,0b00100000,0b01010000,0b01010000,0b10001000,0b10001000,0b10001000,0b01010000,0b01010000,0b00100000
	.db 0b00110000,0b01001000,0b01001000,0b10000100,0b10000100,0b10000100,0b01001000,0b01001000,0b00110000,0b00010000,0b00101000,0b01000100,0b01000100,0b10000010,0b01000100,0b01000100,0b00101000,0b00010000
	.db 0b00000000,0b00000000,0b00000000,0b00000000,0b10000000,0b00000000,0b00000000,0b00000000,0b00000000,0b10000000,0b11000000,0b11100000,0b11110000,0b11111000,0b11110000,0b11100000,0b11000000,0b10000000
	.db 0b00001000,0b00011000,0b00111000,0b01111000,0b11111000,0b01111000,0b00111000,0b00011000,0b00001000  	,-1 //filler

gcharm:
	.db 0b00111000,0b01001100,0b01010100,0b01100100,0b00111000,0b00010000,0b00110000,0b00010000,0b00010000,0b00111000
	.db 0b00111000,0b01000100,0b00011000,0b00110000,0b01111100,0b01111100,0b00001000,0b00011000,0b01000100,0b00111000
	.db 0b00011000,0b00101000,0b01001000,0b01111100,0b00001000,0b01111100,0b01000000,0b01111000,0b00000100,0b00111000
	.db 0b00111000,0b01000000,0b01111000,0b01000100,0b00111000,0b01111100,0b00000100,0b00001000,0b00010000,0b00010000
	.db 0b00111000,0b01000100,0b00111000,0b01000100,0b00111000,0b00111000,0b01000100,0b00111100,0b00001000,0b00110000
	.db 0b00111000,0b01000100,0b01000100,0b01111100,0b01000100,0b01111000,0b00100100,0b00111000,0b00100100,0b01111000
	.db 0b00111000,0b01000100,0b01000000,0b01000100,0b00111000,0b01111000,0b00100100,0b00100100,0b00100100,0b01111000
	.db 0b01111100,0b01000000,0b01111000,0b01000000,0b01111100,0b01111100,0b01000000,0b01111000,0b01000000,0b01000000

gcharmb:
	.db 0b10000000,0b00000000,0b00000000,0b00000000,0b00000000,0b00000000,0b10000000,0b10000000,0b10000000,0b10000000,0b10000000,0b10000000,0b10000000,0b10000000
	.db 0b00000000,0b00000000,0b00000000,0b10000000,0b00000000,0b00000000,0b00000000		,-1 //filler

/*
00001110
00010011
00010101
00011001
00001110

00000100
00001100
00000100
00000100
00001110

00001110
00010001
00000110
00001100
00011111

00011111
00000010
00000110
00010001
00001110

00000110
00001010
00010010
00011111
00000010

00011111
00010000
00011110
00000001
00001110

00001110
00010000
00011110
00010001
00001110

00011111
00000001
00000010
00000100
00000100

00001110
00010001
00001110
00010001
00001110

00001110
00010001
00001111
00000010
00001100

00001110
00010001
00010001
00011111
00010001

00011110
00001001
00001110
00001001
00011110

00001110
00010001
00010000
00010001
00001110

00011110
00001001
00001001
00001001
00011110

00011111
00010000
00011110
00010000
00011111

00011111
00010000
00011110
00010000
00010000

00010000
00100000
00100000
01000000
10000000
01000000
00100000
00100000
00010000

10000000
01000000
01000000
00100000
00010000
00100000
01000000
01000000
10000000

10000000
00000000
00000000
00000000
00000000
00000000
00000000
00000000
10000000

10000000
10000000
10000000
10000000
10000000
10000000
10000000
10000000
10000000

11000000
11000000
11000000
11000000
11000000
11000000
11000000
11000000
11000000

01000000
01000000
10100000
10100000
10100000
10100000
10100000
01000000
01000000

01100000
01100000
10010000
10010000
10010000
10010000
10010000
01100000
01100000

00100000
01010000
01010000
10001000
10001000
10001000
01010000
01010000
00100000

00110000
01001000
01001000
10000100
10000100
10000100
01001000
01001000
00110000

00010000
00101000
01000100
01000100
10000010
01000100
01000100
00101000
00010000

00000000
00000000
00000000
00000000
10000000
00000000
00000000
00000000
00000000

10000000
11000000
11100000
11110000
11111000
11110000
11100000
11000000
10000000

00001000
00011000
00111000
01111000
11111000
01111000
00111000
00011000
00001000

*/

init: ldi r16,LOW(RAMEND)
	out SPL,r16
	ldi r16,HIGH(RAMEND)
	out SPH,r16

	ldi r16,1<<SE		;enable sleep mode
	out SMCR,r16

	ldi r16,$fe
	out PORTB,r16
	out DDRB,r16
	clr r16
	out DDRA,r16
	out DDRC,r16
	out MCUCR,r16
	ldi r16,-1
	out PORTA,r16
	out PORTC,r16

	ldi XL,LOW(kstate)
	ldi XH,HIGH(kstate)
	ldi r17,LOW(gbuf-kstate)
	call clr_mem
	ldi r16,127
	sts meas_rgt,r16
	ldi r16,125
	sts OCR2A,r16
	ldi r16,1<<CS22			;prescaler 64
	sts TCCR2B,r16
	ldi r16,1<<WGM21		;CTC mode
	sts TCCR2A,r16
	call trc_set_clock

	call trc_clr_mem

	ldi r16,30				;to give systimer a chance to detect already pressed buttons
init_wt: sleep
	dec r16
	brne init_wt
	lds r16,keys
	cpi r16,1<<middle_bttn|1<<right_bttn|1<<left_bttn	;check for prefs reset
	brne load_dprefs
	ldi ZL,LOW(EEPROMEND)
	ldi ZH,HIGH(EEPROMEND)
	ldi r16,-1
	out EEDR,r16
erase_eepr_lp: sbic EECR,EEPE
	rjmp erase_eepr_lp
	out EEARH,ZH
	out EEARL,ZL
	sbi EECR,EEMPE
	sbi EECR,EEPE
	sbiw ZH:ZL,1
	brpl erase_eepr_lp
	rcall wt_for_keyrel

load_dprefs: call eepr_get_prslot
	sbiw ZH:ZL,prefsize
	brcc prefs1
	ldi ZL,LOW((dprefs-1)*prefsize)
	ldi ZH,HIGH((dprefs-1)*prefsize)
prefs1: call load_chk_prefs
	rcall lcd_init

restart: rcall clr_gbuf
	rcall clear_allscr
	ldi r16,$80				;OR mode
	rcall lcd_cmd
	ldi r20,0			;measurement mode off
	in r16,tr_mode
	andi r16,$3f		;set show features, reset change flag
	out tr_mode,r16
	rcall ser_gen_bs
	rcall show_trc
	clr r16
	sts cnt1,r16
	sts cnt2,r16

main_loop:
	clr r2			;r2 will be set <>0 if any value (scale, offset) was changed
	tst r20			;r20<>0 if in measurement mode
	breq scale_set
	rcall set_meas
	rjmp offsx
;handle scale controlled with left encoder
scale_set: lds r16,cnt1
	tst r16
	breq scale_setx
	clr r17
	sts cnt1,r17
	lds r17,tscale
	add r17,r16
	brpl scale_set1
	cpi r17,-4
	brge scale_set2
	ldi r17,-4
	rjmp scale_set2
scale_set1: cpi r17,5
	brlo scale_set2
	ldi r17,4
scale_set2: sts tscale,r17
	inc r2
	rcall chk_troffs0
scale_setx:

;handle offset with right encoder
	lds r17,cnt2
	tst r17
	breq offsx
	inc r2
	clr r16
	sts cnt2,r16
	mov r0,r17
	tst r17
	brpl offs1
	neg r17
offs1: clt
	cpi r17,9
	brlo offs2
	ldi r17,8
	set
offs2: lds r16,tscale
	tst r16
	brpl offs3
	ldi r16,1
offs3: add r16,r16
	add r16,r16
	add r16,r16
	add r16,r17
	ldi ZL,LOW(encsc*2-1)
	ldi ZH,HIGH(encsc*2-1)
	add ZL,r16
	clr r16
	adc ZH,r16
	lpm r17,Z
	tst r0
	brpl offs4
	neg r17
offs4: rcall get_tscale
	tst r16
	brpl offs5
	ldi r16,1
offs5: mulsu r17,r16
	brtc offs6
	add r0,r0
	adc r1,r1
offs6: rcall chk_troffs

offsx: tst r2			;scale or offset changed?
	breq wait
	rcall show_trc		;yes, redraw trace
wait: clr r17
waitlp:
	lds r16,keys
	cpi r16,1<<left_enc_sw|1<<right_enc_sw
	breq screenshot
	cpi r16,1<<middle_bttn|1<<right_bttn
	breq trc_dmp
	sbrc r16,middle_bttn
	rjmp menu_settings
	sbrc r16,right_bttn
	rjmp menu_lines
	sbrc r16,left_bttn
	jmp start_trace
	sbrc r16,left_enc_sw
	rjmp tgl_meas
	sbrc r16,right_enc_sw
	rjmp tgl_display
	sleep
	dec r17
	brne waitlp
	rjmp main_loop
tgl_meas: com r20
	rcall wt_for_keyrel
tgl_cm: rcall show_trc
	rjmp wait
tgl_display: in r0,tr_mode
	ldi r18,$80
	eor r0,r18
	out tr_mode,r0
	rcall wt_for_keyrel
	rcall clear_gscr
	rjmp tgl_cm

screenshot: rjmp screenshot_
trc_dmp: jmp trc_dmp_

set_meas:
	lds r17,meas_lft
	lds r18,meas_rgt
	lds r16,cnt1
	tst r16
	breq set_meas1
	inc r2
	add r17,r16
	brvc set_measlft1
	ldi r17,127
	cln
set_measlft1: brpl set_measlft2
	ldi r17,0
set_measlft2: cp r17,r18
	brcs set_measlft3
	mov r17,r18
set_measlft3: sts meas_lft,r17
	clr r16
	sts cnt1,r16
set_meas1: lds r16,cnt2
	tst r16
	breq set_measx
	inc r2
	add r18,r16
	brvc set_measrgt1
	ldi r18,127
	cln
set_measrgt1: brpl set_measrgt2
	ldi r18,0
set_measrgt2: cp r17,r18
	brcs set_measrgt3
	mov r18,r17
set_measrgt3: sts meas_rgt,r18
	clr r16
	sts cnt2,r16
set_measx: ret

menu_lines: ldi ZL,LOW(menu3*2)
	ldi ZH,HIGH(menu3*2)
	rcall build_menu
	rcall mod_menu3
	ldi r20,3				;menu number
	rjmp menu

menu_prefa: ldi ZL,LOW(prefsize*dprefs)
	ldi ZH,HIGH(prefsize*dprefs)
	lds r16,prefno
	andi r16,$7f
	ldi r17,prefsize
	mul r16,r17
	add ZL,r0
	adc ZH,r1
	lds r16,prefno
	tst r16
	brmi menu_exit2
	call load_chk_prefs
	call trc_clr_mem
	rjmp menu_exit1

menu_settings: ldi ZL,LOW(menu1*2)
	ldi ZH,HIGH(menu1*2)
	rcall build_menu
	ldi r20,1				;menu number
;the menu handler is not that generic as it should/could be
;there is some explicitly hardcoded stuff to handle trigger settings or manually defined serial bitclock 
menu:
	rcall wt_for_keyrel
	rcall clear_allscr
	ldi r16,$84				;text attribute mode
	rcall lcd_cmd
	ldi r18,0				;first menu object
	ldi r19,1				;modification mask
	clr r10					;modify mode
menu_redr: push r18
	push r19
	rcall lcd_menu
	pop r19
	pop r18
menu_lp: 
	ldi ZL,LOW(line)
	ldi ZH,HIGH(line)
	ld r15,Z
	dec r15
	mov r16,r18
	rcall get_menu_obidx
	mov r14,r16
	mov r12,r17
	rcall lcd_atptr
	ldi ZL,LOW(menu_oblen*2-1)
	ldi ZH,HIGH(menu_oblen*2-1)
	cpi r17,line_obj_no
	brcs menu_len1
	ldi r17,line_obj_no
menu_len1: add ZL,r17
	ldi r17,0
	adc ZH,r17
	lpm r17,Z
	mov r13,r17
	tst r17
	brpl menu_lp1
	ldi r17,8
	mov r0,r19
	tst r10
	breq menu_lpspc1
	com r0
menu_lpspc1: ldi r16,0
	lsr r0
	brcc menu_spc1
	ldi r16,8
menu_spc1: rcall lcd_chr
	dec r17
	brne menu_lpspc1
	rjmp menu_keys
menu_exit: rcall wt_for_keyrel
	sbis tr_mode,6					;any changes?
	rjmp restart
menu_exit1: call eepr_get_prslot	;yes, save new default preferences
menu_exit2: call eepr_save_prefs
	rjmp restart
menu_lp1: ldi r16,8
	rcall lcd_chr
	dec r17
	brne menu_lp1
menu_keys: sleep
	lds r16,keys
	ldi r17,1<<middle_bttn|1<<right_bttn
	and r17,r16
	brne menu_exit
	sbrs r16,right_enc_sw		;right encoder switch not pressed?
	rjmp menu_2
	rcall wt_for_keyrel
	mov r16,r12
	cpi r16,trigger_obj_no
	brne menu_1
	com r10						;toggle modify mode
	rjmp menu_redr
menu_1: cpi r16,prefs_obj_no
	brne menu_2
	rjmp menu_prefa
menu_2: cpi r20,3				;menu #3?
	brne menu_3
	sbrs r16,left_enc_sw
	rjmp menu_3
	rcall wt_for_keyrel
	ldi YL,LOW(inp_def)
	ldi YH,HIGH(inp_def)
	mov r16,r12
	subi r16,menu3_base		;menu3 base object
	add YL,r16
	ldi r16,0
	adc YH,r16
	ld r16,Y
	cpi r16,ser_modes
	brcs menu_3
	rcall menu3_set_sbase	;set manual bitclock definition for serial line
	rjmp menu_redr
menu_3: lds r16,cnt1
	tst r16
	breq menu_6
	add r18,r16
	ldi r16,0
	sts cnt1,r16
	brpl menu_4
	clr r18
menu_4: cp r18,r15
	breq menu_5
	brcs menu_5
	mov r18,r15
menu_5: mov r16,r14
	rcall lcd_atptr
menu_lp2: clr r16
	rcall lcd_chr
	dec r13
	brne menu_lp2
	rjmp menu_lp
menu_6: lds r16,cnt2
	tst r16
	breq menu_keys
	ldi r17,0
	sts cnt2,r17
	ldi ZL,LOW(menu_actions1*2-2)
	ldi ZH,HIGH(menu_actions1*2-2)
	mov r17,r12
	cpi r17,line_obj_no
	brcs menu_7
	ldi r17,line_obj_no
menu_7: add r17,r17
	add ZL,r17
	ldi r17,0
	adc ZH,r17
	lpm r0,Z+
	lpm ZH,Z
	mov ZL,r0
	icall
	rjmp menu_redr

menu3_set_sbase: 
	ldi YL,LOW(ser_base)
	ldi YH,HIGH(ser_base)
	mov r16,r12
	subi r16,menu3_base		;menu3 base object
	add r16,r16
	add YL,r16
	ldi r16,0
	adc YH,r16
	ldd r16,Y+1
	tst r16
	brpl menu3_set_sbase1
	clr r0
	clr r1
	rjmp menu3_set_sbasex
menu3_set_sbase1: lds r0,meas_rgt
	lds r1,meas_lft
	sub r0,r1
	lds r16,tscale
	tst r16
	brpl menu3_set_sbase2
	push r18
	ldi ZL,LOW(sfact*2+8)
	ldi ZH,HIGH(sfact*2+8)
	add r16,r16
	add ZL,r16
	ldi r16,-1
	adc ZH,r16
	lpm r17,Z+
	lpm r18,Z
	mov r16,r0
    mul r17,r16 
    mov r17,r1
    mul r18,r16 
    add r0,r17
	clr r16
	adc r1,r16
	rcall shift_4right
	pop r18
	rjmp menu3_set_sbase3
menu3_set_sbase2: rcall get_tscale
	add r16,r16
	add r16,r16
	add r16,r16
	mul r0,r16
	add r0,r0
	adc r1,r1
menu3_set_sbase3: mov r16,r0
	or r16,r1
	brne menu3_set_sbase4
	inc r0
menu3_set_sbase4: ldi r16,$80
	or r1,r16
menu3_set_sbasex: st Y+,r0
	st Y,r1
	ret

get_menu_obidx: adiw ZH:ZL,1
get_menu_obxlp:	ld r0,Z+
	ldi r17,16
	mul r0,r17
	ld r17,Z+
	add r17,r0
get_menu_obskp: ld r0,Z+
	inc r17
	tst r0
	brne get_menu_obskp
	ld r0,Z+
	tst r0
	breq get_menu_obxlp
	brmi get_menu_obxlp
	dec r16
	brpl get_menu_obxlp
	mov r16,r17
	dec r16
	mov r17,r0
	ret

build_menu: ldi YL,LOW(line)
	ldi YH,HIGH(line)
	lpm r16,Z+
	st Y+,r16
build_menu_lp2: lpm r16,Z+
	st Y+,r16
	cpi r16,-1
	brne build_menu_1
	ret
build_menu_1: lpm r16,Z+
	st Y+,r16
build_menu_lp1: lpm r16,Z+
	st Y+,r16
	tst r16
	brne build_menu_lp1
	lpm r16,Z+
	st Y+,r16
	rjmp build_menu_lp2

mod_menu3: push r19
	ldi r17,menu3_base		;base object menu3
	clr r18
	clr r19
	ldi XL,LOW(inp_def)
	ldi XH,HIGH(inp_def)
	ldi YL,LOW(line+1)
	ldi YH,HIGH(line+1)
mod_menu3_lp1: ld r16,Y
	tst r16
	brpl mod_menu3_1
	sts line,r18
	pop r19
	ret
mod_menu3_1: inc r18
	ld r16,X
	cpi r16,ser_modes
	brcs mod_menu3_2
	clr r16								;use the entry for single line
mod_menu3_2: ldi ZL,LOW(menu3_len*2)
	ldi ZH,HIGH(menu3_len*2)
	add ZL,r16
	ldi r16,0
	adc ZH,r16
	lpm r16,Z
	ldi ZL,LOW(mod_menu3_jt)
	ldi ZH,HIGH(mod_menu3_jt)
	add ZL,r16
	ldi r16,0
	adc ZH,r16
	icall
	sbic tr_mode,1
	rjmp mod_menu3_lp1
	cpi r19,8
	brcs mod_menu3_lp1
	ldi r16,-1
	st Y,r16
	rjmp mod_menu3_lp1

mod_menu3_jt:
	rjmp mod_menu31
	rjmp mod_menu32
	rjmp mod_menu34

mod_menu31: adiw XH:XL,1
	rcall mod_menu3_gob
	st Y+,r17
	inc r17
	inc r19
	ret
mod_menu32: adiw XH:XL,2
	rcall mod_menu3_gob
	st Y+,r17
	inc r17
	subi r19,-2
	rjmp mod_menu3_inv
mod_menu34: adiw XH:XL,4
	rcall mod_menu3_gob
	st Y+,r17
	inc r17
	subi r19,-4
	rcall mod_menu3_inv
	rcall mod_menu3_inv
	rjmp mod_menu3_inv

mod_menu3_inv: rcall mod_menu3_gob
	mov r16,r17
	neg r16
	st Y+,r16
	inc r17
	ret

mod_menu3_gob: adiw YH:YL,2
mod_menu3_glp: ld r0,Y+
	tst r0
	brne mod_menu3_glp
	ret

ch_trig: tst r10
	breq ch_trig1
mod_mmsk: tst r16
	brmi mod_mmsk1
	lsl r19
	brcc mod_mmskx
	ldi r19,1
mod_mmskx: ret
mod_mmsk1: lsr r19
	brcc mod_mmskx
	ldi r19,$80
	rjmp mod_mmskx
ch_trig1: sbi tr_mode,6
	tst r16
	brmi ch_trig2
	lds r16,tr_mask1
	mov r0,r16
	and r0,r19
	brne ch_trig11
	eor r16,r19
	sts tr_mask1,r16
	mov r0,r19
	com r0
	lds r16,trigger1
	and r16,r0
	sts trigger1,r16
	rjmp ch_trigx		
ch_trig11: lds r16,trigger1
	eor r16,r19
	sts trigger1,r16
	and r16,r19
	brne ch_trigx
	lds r16,tr_mask1
	eor r16,r19
	sts tr_mask1,r16
	rjmp ch_trigx
ch_trig2: lds r16,tr_mask1
	mov r0,r16
	and r0,r19
	brne ch_trig21
	eor r16,r19
	sts tr_mask1,r16
	lds r16,trigger1
	or r16,r19
	sts trigger1,r16
	rjmp ch_trigx
ch_trig21: lds r16,trigger1
	eor r16,r19
	sts trigger1,r16
	mov r0,r16
	and r16,r19
	breq ch_trigx
	lds r16,tr_mask1
	eor r16,r19
	sts tr_mask1,r16
	and r0,r16
	sts trigger1,r0
ch_trigx: ret

ch_mode: ldi r16,1
	in r17,tr_mode
	eor r17,r16
	out tr_mode,r17
	sbi tr_mode,6
	ret

ch_lines: ldi r16,2
	in r17,tr_mode
	eor r17,r16
	out tr_mode,r17
	sbi tr_mode,6
	jmp trc_clr_mem

ch_sclk: lds r17,sclk
	add r17,r16
	brpl ch_sclk1
	clr r17
ch_sclk1: cpi r17,19
	brcs ch_sclk3
	ldi r17,19
ch_sclk3: sts sclk,r17
	clr r16
	sts tscale,r16
	sbi tr_mode,6
	jmp trc_clr_mem

ch_prefno: lds r0,prefno
	ldi r17,$80
	and r17,r0
	push r17
	lds r17,prefno
	andi r17,$7f
	tst r16
	brmi ch_prefno1
	inc r17
	cpi r17,9
	brcs ch_prefno2
	clr r17
	rjmp ch_prefno2
ch_prefno1: dec r17
	brpl ch_prefno2
	ldi r17,8
ch_prefno2: pop r16
	or r17,r16
	sts prefno,r17
	ret

ch_pact: lds r16,prefno
	ldi r17,$80
	eor r16,r17
	sts prefno,r16
	ret

ch_lcd_pwm: lds r17,lcd_pwm
	tst r16
	brmi ch_lcd_pwm1
	sub r17,r16
	brmi ch_lcd_pwm2
	ldi r17,128
	rjmp ch_lcd_pwm2
ch_lcd_pwm1: neg r16
	add r17,r16
	brmi ch_lcd_pwm2
	ldi r17,128+127
ch_lcd_pwm2: sts lcd_pwm,r17
	out OCR0A,r17
	sbi tr_mode,6
	ret

show_trig: ldi r19,8
	lds r17,tr_mask1
	lds r18,trigger1
show_trig_lp: ldi r16,'L'-32
	lsr r18
	brcc show_trig1
	ldi r16,'H'-32
show_trig1: lsr r17
	brcs show_trig2
	ldi r16,'-'-32
show_trig2: rcall lcd_chr
	dec r19
	brne show_trig_lp
	ret

show_mode: ldi ZL,LOW(mode_pretx*2)
	ldi ZH,HIGH(mode_pretx*2)
	sbis tr_mode,0
	rjmp lcd_str
	ldi ZL,LOW(mode_posttx*2)
	ldi ZH,HIGH(mode_posttx*2)
	rjmp lcd_str

show_sclk: ldi ZL,LOW(mode_sclk*2)
	ldi ZH,HIGH(mode_sclk*2)
	clr r17
	lds r16,sclk
	tst r16
	brne show_sclk1
	sbic tr_mode,1
	ldi r16,20			;special for 16 channels @ 5 MHz
show_sclk1: add ZL,r16
	adc ZH,r17
	lpm r16,Z
	ldi ZL,LOW(mode_sclki*2)
	ldi ZH,HIGH(mode_sclki*2)
	add ZL,r16
	adc ZH,r17
show_sclklp: lpm r16,Z+
	mov r17,r16
	andi r16,$7f
	rcall lcd_chr
	tst r17
	brpl show_sclklp
	ldi ZL,LOW(hz_tx*2)
	ldi ZH,HIGH(hz_tx*2)
	rjmp lcd_str

show_lines:
	ldi r16,'8'-32
	sbic tr_mode,1
	ldi r16,'1'-32
	rcall lcd_chr
	ldi r16,' '-32
	sbic tr_mode,1
	ldi r16,'6'-32
	rjmp lcd_chr

show_prefno: lds r16,prefno
	andi r16,$7f
	subi r16,-$11
	rjmp lcd_chr

show_pact: lds r16,prefno
	ldi ZL,LOW(prefa_tx*2)
	ldi ZH,HIGH(prefa_tx*2)
	sbrc r16,7
	adiw ZH:ZL,5
	rjmp lcd_str

show_lcd_pwm: lds r16,lcd_pwm
	ldi r17,128+127
	sub r17,r16
	subi r17,-8
	swap r17
	andi r17,15
	clr r19
	ldi r16,'='-32
show_lcd_pwm_lp: cp r17,r19
	brne show_lcd_pwm1
	ldi r16,'-'-32
show_lcd_pwm1: push r16
	rcall lcd_chr
	pop r16
	inc r19
	cpi r19,8
	brne show_lcd_pwm_lp
	ret

show_ln: subi r16,line_obj_no
	push r18
	mov r0,r16
	andi r16,$fc
	ldi ZL,LOW(ln_p2*2)
	ldi ZH,HIGH(ln_p2*2)
	rcall show_ln_gt
	brne show_ln0
	mov r16,r0
	andi r16,$fe
	ldi ZL,LOW(ln_p1*2)
	ldi ZH,HIGH(ln_p1*2)
	rcall show_ln_gt
	brne show_ln0
	mov r16,r0
	ldi ZL,LOW(ln_p*2)
	ldi ZH,HIGH(ln_p*2)
	rcall show_ln_gt
	breq show_ln1
show_ln0: ldi ZL,LOW(show_ln_jt-1)
	ldi ZH,HIGH(show_ln_jt-1)
	add ZL,r18
	ldi r18,0
	adc ZH,r18
	ijmp
show_ln1: rcall show_ln_tp
	pop r18
	ret

show_ln_gt: clr r18
	ldi YL,LOW(inp_def)
	ldi YH,HIGH(inp_def)
	add YL,r16
	adc YH,r18
	ld r17,Y
	cpi r17,ser_modes
	brcc show_ln_gt1	;serial modes always only one line
	add ZL,r17
	adc ZH,r18
	lpm r18,Z
show_ln_gt1: tst r18
	ret

show_ln_tp: ldi ZL,LOW(ln_modx*2)
	ldi ZH,HIGH(ln_modx*2)
show_ln_tplp2: tst r17
	breq show_ln_tp1
show_ln_tplp1: lpm r0,Z+
	tst r0
	brne show_ln_tplp1
	dec r17
	rjmp show_ln_tplp2
show_ln_tp1: push r16
	rcall lcd_str
	pop r16
	ldi YL,LOW(inp_def)
	ldi YH,HIGH(inp_def)
	add YL,r16
	ldi r17,0
	adc YH,r17
	ld r17,Y
	cpi r17,ser_modes
	brcc show_ln_tp2
	ret
show_ln_tp2: add r16,r16
	ldi YL,LOW(ser_base+1)
	ldi YH,HIGH(ser_base+1)
	add YL,r16
	ldi r16,0
	adc YH,r16
	ld r16,Y
	tst r16
	ldi r16,0
	brpl show_ln_tpx
	ldi r16,'*'-32
show_ln_tpx: rjmp lcd_chr

show_ln_jt:
	rjmp show_ln_nib
	rjmp show_ln_i2c
	rjmp show_ln_spi

show_ln_nib: push r16
	rcall show_ln_tp
	pop r16
	andi r16,$fc
	ldi ZL,LOW(nib_tx*2)
	ldi ZH,HIGH(nib_tx*2)
	add ZL,r16
	ldi r16,0
	adc ZH,r16
	rcall lcd_str
	clr r16
	rcall lcd_chr
	pop r18
	ret

show_ln_i2c: push r0
	rcall show_ln_tp
	pop r16
	andi r16,1
	ldi r17,7
	mul r16,r17
	ldi ZL,LOW(i2c_tx*2)
	ldi ZH,HIGH(i2c_tx*2)
	add ZL,r0
	adc ZH,r1
	rcall lcd_str
	pop r18
	ret

show_ln_spi: push r0
	rcall show_ln_tp
	pop r16
	andi r16,3
	ldi r17,5
	mul r16,r17
	ldi ZL,LOW(spi_tx*2)
	ldi ZH,HIGH(spi_tx*2)
	add ZL,r0
	adc ZH,r1
	rcall lcd_str
	pop r18
	ret

ch_ln: mov r17,r12
	subi r17,line_obj_no
	push r18
	push r17
	ldi XL,LOW(inp_def)
	ldi XH,HIGH(inp_def)
	add XL,r17
	ldi r18,0
	adc XH,r18
	ld r18,X
	ldi ZL,LOW(lnt*2)
	ldi ZH,HIGH(lnt*2)
	add r17,r17
	add ZL,r17
	ldi r17,0
	adc ZH,r17
	lpm r17,Z+
	lpm ZH,Z
	mov ZL,r17
ch_ln_lp1: lpm r17,Z
	cp r18,r17
	breq ch_ln0
	adiw ZH:ZL,1
	rjmp ch_ln_lp1
ch_ln0:	tst r16
	brpl ch_ln1
	dec r18
	ldi r18,0
	brmi ch_ln2
	sbiw ZH:ZL,1
	lpm r18,Z
	rjmp ch_ln2
ch_ln1: adiw ZH:ZL,1
	lpm r18,Z
	cpi r18,-1
	brne ch_ln2
	sbiw ZH:ZL,1
	lpm r18,Z
ch_ln2: st X,r18
	pop r17
	cpi r18,ser_modes
	brcc ch_ln3
	add r17,r17
	ldi XL,LOW(ser_base)
	ldi XH,HIGH(ser_base)
	add XL,r17
	ldi r17,0
	adc XH,r17
	st X+,r17
	st X,r17
ch_ln3:	rcall mod_menu3
	pop r18
	sbi tr_mode,6
	ret

ser_gen_bs: push r20
	ldi YL,LOW(inp_def)
	ldi YH,HIGH(inp_def)
	clr r17
ser_gen_bslp: ld r16,Y+
	cpi r16,ser_modes
	brcs ser_gen_bsnx
	push r17
	push YL
	push YH
	mov r16,r17
	add r16,r16
	ldi YL,LOW(ser_base)
	ldi YH,HIGH(ser_base)
	add YL,r16
	ldi r16,0
	adc YH,r16
	ldd r16,Y+1
	tst r16
	brmi ser_gen_bsnx1
	push YL
	push YH
	ldi r16,7
	and r16,r17
	ldi r20,1
ser_gen_bslp1: tst r16
	breq ser_gen_bs1
	lsl r20
	dec r16
	rjmp ser_gen_bslp1
ser_gen_bs1:
	ldi YL,LOW(trace)
	ldi YH,HIGH(trace)
	cpi r17,8
	brcs ser_gen_bs2
	adiw YH:YL,1
ser_gen_bs2:
	rcall ser_base_ev
	pop YH
	pop YL
	ldi r16,$7f
	cp r16,r15
	brne ser_gen_bs3
	clr r14
	clr r15
ser_gen_bs3: st Y+,r14
	st Y,r15
ser_gen_bsnx1: pop YH
	pop YL
	pop r17
ser_gen_bsnx: inc r17
	cpi r17,16
	brne ser_gen_bslp
	pop r20
	ret

show_trc: push r20
	mov r12,r20
	rcall lcd_thome
	ldi ZL,LOW(scaletx*2)
	ldi ZH,HIGH(scaletx*2)
	lds r16,sclk
	tst r16
	brne show_trc1
	sbic tr_mode,1
	ldi r16,20			;special for 0,2us
show_trc1: ldi r17,9
	mul r16,r17
	add ZL,r0
	adc ZH,r1
	lds r16,tscale
	clr r17
	sbrc r16,7
	dec r17
	add ZL,r16
	adc ZH,r17
	lpm r16,Z
	add r16,r16
	add r16,r16
	ldi ZL,LOW(scaletxi*2)
	ldi ZH,HIGH(scaletxi*2)
	add ZL,r16
	ldi r16,0
	adc ZH,r16
	ldi r17,4
show_trcsclp: lpm r16,Z+
	rcall lcd_chr
	dec r17
	brne show_trcsclp
	ldi r16,'s'-32
	rcall lcd_chr
	ldi r16,$81
	rcall lcd_chr
	ldi r16,$82
	rcall lcd_chr
	tst r12
	breq show_trcoffs
	ldi r16,$83
	rcall lcd_chr
	lds r0,meas_rgt
	lds r1,meas_lft
	sub r0,r1
	rcall get_tscale
	tst r16
	brpl show_trcdlt
	rcall binascs
	rjmp show_trcp1
show_trcdlt: mul r0,r16
	rjmp show_trcpos
show_trcoffs: clr r16
	sbis tr_mode,0
	rcall lcd_chr	;additional space only if pretrig mode
	lds r0,trace_offset
	lds r1,trace_offset+1

show_trcpos: mov r17,r12
	rcall binasc
	lds r16,sclk
	add r16,r16
	ldi ZL,LOW(mode_tm*2)
	ldi ZH,HIGH(mode_tm*2)
	add ZL,r16
	ldi r16,0
	adc ZH,r16
show_trcp1: lpm r16,Z+
	rcall lcd_chr
	lpm r16,Z
	clr r17
	cpse r16,r17
	rcall lcd_chr

	rcall get_tscale
	mov r19,r16			;timescale
	clr r15				;line offset
	ldi r21,8			;Y offset
	ldi r22,9			;timediv
	clr r14				;line index
show_trclp3: ldi r20,1	;bitmask
show_trclp2: sbic tr_mode,7
	rjmp show_trc_sl
	clr r16
	ldi YL,LOW(inp_def)
	ldi YH,HIGH(inp_def)
	add YL,r14
	adc YH,r16
	ld r17,Y
	tst r17
	breq show_trc_sl
	rcall show_features
	rjmp show_trc_nxt
show_trc_sl: ldi XL,LOW(trace)
	ldi XH,HIGH(trace)
	lds r2,trace_offset
	lds r3,trace_offset+1
	clr r0
	sbic tr_mode,1
	add r2,r2
	sbic tr_mode,1
	adc r3,r3
	add r2,r15
	adc r3,r0
	add XL,r2
	adc XH,r3
	ldi r24,LOW(gbuf)
	ldi r25,high(gbuf)
	ld r0,X
	and r0,r20
	ldi r16,16
	ldi r23,-1
	tst r19
	brpl show_trclp1
	mov r3,r19
	neg r3
show_trclp1: movw YH:YL,r25:r24
	ldi r18,8
	clr r8
	clr r9
	clr r10
	clr r11
show_trclp: clr r4
	sbrs r19,7
	mov r3,r19
show_trclpi: ld r1,X
	and r1,r20
	mov r2,r1
	eor r2,r0
	or r4,r2
	tst r19
	brmi show_trcs
	adiw XH:XL,1
	sbic tr_mode,1
	adiw XH:XL,1
	dec r3
	brne show_trclpi
show_trcs: mov r0,r1
	tst r4
	breq show_trcln
	sec
	rol r8
	sec
	rol r9
	sec
	rol r10
	sec
	rol r11
	rjmp show_trc_1
show_trcln: tst r1
	brne show_trch
	mov r2,r18
	lsr r2
	rol r8
	sbrc r23,7
	sec	
	rol r9
	lsl r10
	sec
	rol r11
	rjmp show_trc_1
show_trch: sec
	rol r8
	sbrc r23,7
	sec
	rol r9
	lsl r10
	mov r2,r18
	lsr r2
	rol r11
show_trc_1: sbrc r23,7
	mov r23,r22
	dec r23
	dec r18
	breq show_trc_2
	tst r19
	brpl show_trclp
	dec r3
	brne show_trclp
	adiw XH:XL,1
	sbic tr_mode,1
	adiw XH:XL,1
	mov r3,r19
	neg r3
	rjmp show_trclp
show_trc_2: st Y,r8
	std Y+16,r9
	std Y+32,r10
	std Y+48,r9
	adiw YH:YL,32
	adiw YH:YL,32
	st Y,r10
	sbic tr_mode,1
	rjmp show_trc_3
	std Y+16,r9
	std Y+32,r10
	std Y+48,r9
	adiw YH:YL,32
	adiw YH:YL,16
show_trc_3: adiw YH:YL,16
	st Y,r11
	clr r2
	std Y+16,r2
	adiw r25:r24,1
	dec r16
	breq show_trc_5
	tst r19
	brpl show_trc_4
	dec r3
	brne show_trc_4
	adiw XH:XL,1
	sbic tr_mode,1
	adiw XH:XL,1
	mov r3,r19
	neg r3
show_trc_4: rjmp show_trclp1
show_trc_5: rcall show_meas
	ldi r18,160
	sbic tr_mode,1
	ldi r18,112
	rcall send_gbuf1
	subi r21,-7
	sbis tr_mode,1
	subi r21,-3
	inc r14
show_trc_nxt: lsl r20
	breq show_trc_6
	rjmp show_trclp2
show_trc_6: sbis tr_mode,1
	rjmp show_trcx
	subi r21,-2
	inc r15
	ldi r16,2
	cpse r15,r16
	rjmp show_trclp3
show_trcx: pop r20
	ret

show_features: cpi r17,ser_modes
	brcc show_features1
	ldi ZL,LOW(trc_sh_spc-1)
	ldi ZH,HIGH(trc_sh_spc-1)
	add ZL,r17
	adc ZH,r16
	ijmp
show_features1: rjmp show_ser_

show_msln: ldi YL,LOW(gbuf)
	ldi YH,HIGH(gbuf)
	mov r17,r16
	lsr r17
	lsr r17
	lsr r17
	add YL,r17
	ldi r17,0
	adc YH,r17
	andi r16,7
	clr r17
	sec
show_msln1: ror r17
	dec r16
	brpl show_msln1
	ldi r16,10
show_msln2: ld r0,Y
	or r0,r17
	st Y,r0
	adiw YH:YL,16
	dec r16
	brne show_msln2
	ret

chk_troffs0: clr r0
	clr r1
chk_troffs: lds r18,trace_offset
	lds r19,trace_offset+1
	add r18,r0
	adc r19,r1
	brpl chk_troffs1
	clr r18
	clr r19
	rjmp chk_troffs2
chk_troffs1: rcall get_tscale
	tst r16
	brpl chk_troffs2
	lds r16,tscale
	neg r16
	ldi ZL,LOW(time_div*2-1)
	ldi ZH,HIGH(time_div*2-1)
	add ZL,r16
	ldi r16,0
	adc ZH,r16
	lpm r0,Z
	clr r1
	rjmp chk_troffs3
chk_troffs2: ldi r17,128
	mul r16,r17
chk_troffs3: ldi r16,LOW(trace_size)
	ldi r17,HIGH(trace_size)
	sbic tr_mode,1
	ldi r16,LOW(trace_size/2)
	sbic tr_mode,1
	ldi r17,HIGH(trace_size/2)
	sub r16,r0
	sbc r17,r1
	cp r18,r16
	cpc r19,r17
	brcs chk_troffs4
	movw r19:r18,r16:r17
chk_troffs4: sts trace_offset,r18
	sts trace_offset+1,r19
	ret

get_tscale: push r17
	clr r17
	lds r16,tscale
	tst r16
	brpl get_tscale1
	dec r17
get_tscale1: ldi ZL,LOW(scaletab*2)
	ldi ZH,HIGH(scaletab*2)
	add ZL,r16
	adc ZH,r17
	lpm r16,Z
	pop r17
	ret

wt_for_keyrel: sleep
	lds r16,keys
	tst r16
	brne wt_for_keyrel
	ret

shift_4right: lsr r1
	ror r0
	lsr r1
	ror r0
	lsr r1
	ror r0
	lsr r1
	ror r0
	ret

binascs: clr r1
	lds r17,sclk
	tst r17
	brne binascs1
	sbic tr_mode,1
	ldi r17,20		;special for 0.2us
binascs1: push r17
	add r17,r17
	add r17,r17
	lds r16,tscale
	neg r16
	dec r16
	push r16
	add r17,r16
	ldi ZL,LOW(binascs_tab)
	ldi ZH,HIGH(binascs_tab)
	add ZL,r17
	ldi r17,0
	adc ZH,r17
	ldi r17,1		;only positive numbers unsigned
	icall
	pop r16
	pop r17
	ldi ZL,LOW(mode_tms*2)
	ldi ZH,HIGH(mode_tms*2)
	add ZL,r17
	ldi r17,0
	adc ZH,r17
	lpm r17,Z
binascs_lp: dec r16
	brmi binascs2
	lsr r17
	lsr r17
	rjmp binascs_lp
binascs2: andi r17,3
	add r17,r17
	ldi ZL,LOW(mode_tmsi*2)
	ldi ZH,HIGH(mode_tmsi*2)
	add ZL,r17
	ldi r17,0
	add ZH,r17
	ret

binascs_tab:
	rjmp binasc50us		;0.1us
	rjmp binasc20us
	rjmp binasc10us
	rjmp binasc5use
	rjmp binasc25us		;0.5us
	rjmp binasc01us
	rjmp binasc50us
	rjmp binasc2us5
	rjmp binasc05us		;1us
	rjmp binasc02us
	rjmp binasc01usc
	rjmp binasc50us
	rjmp binasc1use		;2us
	rjmp binasc04us
	rjmp binasc02us
	rjmp binasc01usc
	rjmp binasc250us	;5us
	rjmp binasc1use
	rjmp binasc05us
	rjmp binasc25us
	rjmp binasc5use		;10us
	rjmp binasc2use
	rjmp binasc1use
	rjmp binasc05us
	rjmp binasc1000use	;20us
	rjmp binasc400use
	rjmp binasc2use
	rjmp binasc1use
	rjmp binasc2us5		;50us
	rjmp binasc1000use
	rjmp binasc5use
	rjmp binasc250us
	rjmp binasc50us		;100us
	rjmp binasc20us
	rjmp binasc1000use
	rjmp binasc5use
	rjmp binasc01usc	;200us
	rjmp binasc40us
	rjmp binasc20us
	rjmp binasc1000use
	rjmp binasc25us		;500us
	rjmp binasc01us
	rjmp binasc50us
	rjmp binasc2us5
	rjmp binasc05us		;1ms
	rjmp binasc02us
	rjmp binasc01usc
	rjmp binasc50us
	rjmp binasc1use		;2ms
	rjmp binasc04us
	rjmp binasc02us
	rjmp binasc01usc
	rjmp binasc250us	;5ms
	rjmp binasc1use
	rjmp binasc05us
	rjmp binasc25us
	rjmp binasc5use		;10ms
	rjmp binasc2use
	rjmp binasc1use
	rjmp binasc05us
	rjmp binasc1000use	;20ms
	rjmp binasc400use
	rjmp binasc2use
	rjmp binasc1use
	rjmp binasc2us5		;50ms
	rjmp binasc1000use
	rjmp binasc5use
	rjmp binasc250us
	rjmp binasc50use	;100ms
	rjmp binasc20use
	rjmp binasc1000use
	rjmp binasc5use
	rjmp binasc01use	;200ms
	rjmp binasc40use
	rjmp binasc20use
	rjmp binasc1000use
	rjmp binasc25use	;500ms
	rjmp binasc01use
	rjmp binasc50use
	rjmp binasc2us5
	rjmp binasc01usc	;0.2us
	rjmp binasc40us
	rjmp binasc20us
	rjmp binasc1000use

binasc: lds r16,sclk
	ldi ZL,LOW(binasc_tab)
	ldi ZH,HIGH(binasc_tab)
	add ZL,r16
	ldi r16,0
	adc ZH,r16
	ijmp

binasc_tab:
	rjmp binasc01us
	rjmp binasc05us
	rjmp binasc1use
	rjmp binasc2use
	rjmp binasc5use
	rjmp binasc10us
	rjmp binasc20us
	rjmp binasc50us
	rjmp binasc01us
	rjmp binasc200us
	rjmp binasc05us
	rjmp binasc1use
	rjmp binasc2use
	rjmp binasc5use
	rjmp binasc10use
	rjmp binasc20use
	rjmp binasc50use
	rjmp binasc01use
	rjmp binasc200use
	rjmp binasc05use

	.include "binasc.asm"

lcd_menu: ldi ZL,LOW(line+1)
	ldi ZH,HIGH(line+1)			;skip object count
lcd_menu_lp: ld r16,Z+
	tst r16
	brpl lcd_menu1
	ret
lcd_menu1: ldi r17,16
	mul r16,r17
	ld r16,Z+
	add r16,r0
	rcall lcd_txptr
	rcall lcd_strr
	ld r16,Z+
	tst r16
	brpl lcd_menu2
	neg r16
lcd_menu2: mov r0,r16
	cpi r16,line_obj_no
	brcs lcd_menu3
	ldi r16,line_obj_no
lcd_menu3: add r16,r16
	breq lcd_menu_lp
	push ZL
	push ZH
	ldi ZL,LOW(menu_actions*2-2)
	ldi ZH,HIGH(menu_actions*2-2)
	add ZL,r16
	clr r17
	adc ZH,r17
	lpm r17,Z+
	lpm ZH,Z
	mov ZL,r17
	mov r16,r0
	icall
	pop ZH
	pop ZL
	rjmp lcd_menu_lp

lcd_strr: ld r16,Z+
	tst r16
	brne lcd_strr1
	ret
lcd_strr1: subi r16,32
	rcall lcd_chr
	rjmp lcd_strr

lcd_stralt: lpm r16,Z+
	rcall lcd_data
	ldi r16,HIGH(alt_scr)
	rcall lcd_ptr
lcd_str: lpm r16,Z+
	tst r16
	brne lcd_str1
	ret
lcd_str1: subi r16,32
	rcall lcd_chr
	rjmp lcd_str

lcd_data: rcall lcd_status
	cbi PORTB,PB5
	rjmp lcd_write
lcd_chr: rcall lcd_data
	ldi r16,$c0
lcd_cmd: rcall lcd_status
	sbi PORTB,PB5
lcd_write:
	out PORTD,r16
	cbi PORTB,PB7
	rjmp PC+1
	sbi PORTB,PB7
	sei
	ret

lcd_status:	cli
	push r16
	clr r16
	sbi PORTB,PB5
	out DDRD,r16
lcd_st_wt: cbi PORTB,PB6
	rjmp PC+1
	in r16,PIND
	sbi PORTB,PB6
	andi r16,3
	cpi r16,3
	brne lcd_st_wt
lcd_stxx: ldi r16,-1
	out DDRD,r16
	pop r16
	ret

lcd_read: cli
	clr r16
	cbi PORTB,PB5
	out DDRD,r16
	cbi PORTB,PB6
	rjmp PC+1
	nop
	in r16,PIND
	sbi PORTB,PB6
	push r16
	ldi r16,-1
	out DDRD,r16
	pop r16
	sei
	ret

lcd_aw:	cli
	clr r17
	out DDRD,r17
	sbi PORTB,PB5
	clr r1
lcd_staw_wt: cbi PORTB,PB6
	in r17,PIND
	sbi PORTB,PB6
	cbi PORTB,PB6
	in r0,PIND
	and r17,r0
	sbi PORTB,PB6
	dec r1
	breq lcd_stawx
	andi r17,8
	breq lcd_staw_wt
lcd_stawx: ldi r17,-1
	out DDRD,r17
	cbi PORTB,PB5
	out PORTD,r16
	cbi PORTB,PB7
	sbi PORTB,PB7
	sei
	ret

lcd_init: cbi PORTB,2	;LCD Reset
	ldi r16,100
lcd_init_rst: dec r16
	brne lcd_init_rst
	sbi PORTB,2
lcd_init_wt: dec r16
	brne lcd_init_wt

	ldi ZL,LOW(lcd_init_str*2)
	ldi ZH,HIGH(lcd_init_str*2)
lcd_init_lp1: lpm r17,Z+
lcd_init_lp2: lpm r16,Z+
	dec r17
	brmi lcd_init2
	breq lcd_init1
	rcall lcd_data
	rjmp lcd_init_lp2
lcd_init1: rcall lcd_cmd
	rjmp lcd_init_lp1
lcd_init2:

	ldi ZL,LOW(chartab*2)
	ldi ZH,HIGH(chartab*2)
	ldi r18,80
lcd_init_cg: lpm r16,Z+
	rcall lcd_aw
	dec r18
	brne lcd_init_cg
	ldi r16,$b2				;auto reset
	rcall lcd_cmd
	lds r16,lcd_pwm
	out OCR0A,r16
	sts lcd_pwm,r16
	ldi r16,1<<COM0A1|1<<WGM01|1<<WGM00
	out TCCR0A,r16
	ldi r16,1<<CS00
	out TCCR0B,r16
	ret

clear_ascr: rcall lcd_ahome
	rjmp clear_tscr1
clear_tscr: rcall lcd_thome
clear_tscr1: ldi r25,1
	clr r24
	rjmp clear_scrc

clear_allscr: rcall clear_tscr
clear_gscr: rcall lcd_ghome
	ldi r24,LOW(2048)
	ldi r25,HIGH(2048)
clear_scrc:	ldi r16,$b0		;auto write
	rcall lcd_cmd
	clr r16
clear_gscr_lp: rcall lcd_aw
	sbiw r25:r24,1
	brne clear_gscr_lp
	ldi r16,$b2				;auto reset
	rjmp lcd_cmd

lcd_txptr: rcall lcd_data
	ldi r16,HIGH(text_scr)
	rjmp lcd_ptr
lcd_ghome: clr r16
lcd_atptr: rcall lcd_data
	ldi r16,HIGH(graphic_scr)
	rjmp lcd_ptr
lcd_ahome: clr r16
	rcall lcd_data
	ldi r16,HIGH(alt_scr)
	rjmp lcd_ptr
lcd_thome: clr r16
	rcall lcd_data
	ldi r16,HIGH(text_scr)
lcd_ptr: rcall lcd_data
	ldi r16,$24
	rjmp lcd_cmd

clr_gbuf: ldi XL,LOW(gbuf)
	ldi XH,HIGH(gbuf)
	ldi r17,160
clr_mem: clr r16
clr_mlp: st X+,r16
	dec r17
	brne clr_mlp
	ret

send_gbuf2: ldi r18,160
send_gbuf1: mov r16,r21
	ldi r17,16
	mul r16,r17
	clr r16
	ldi r17,HIGH(graphic_scr)
	add r16,r0
	adc r17,r1
	rcall lcd_data
	mov r16,r17
	rcall lcd_data
	ldi r16,$24
	rcall lcd_cmd
	ldi XL,LOW(gbuf)
	ldi XH,HIGH(gbuf)
	ldi r16,$b0				;auto write
	rcall lcd_cmd
send_gblp: ld r16,X+
	rcall lcd_aw
	dec r18
	brne send_gblp
	ldi r16,$b2				;auto reset
	rjmp lcd_cmd

	.if debug==1
dumpreg: push r16
	push r17
	push r18
	push r31
	push r30
	push r29
	push r28
	push r27
	push r26
	push r25
	push r24
	push r23
	push r22
	push r21
	push r20
	push r19
	push r18
	push r17
	push r16
	push r15
	push r14
	push r13
	push r12
	push r11
	push r10
	push r9
	push r8
	push r7
	push r6
	push r5
	push r4
	push r3
	push r2
	push r1
	push r0
	ldi r18,4
dumpreg_lp2: ldi r17,8
dumpreg_lp1: pop r16
	rcall put_hex
	ldi r16,$20
	rcall putchar
	dec r17
	brne dumpreg_lp1
	rcall put_nl
	dec r18
	brne dumpreg_lp2
	rcall put_nl
	pop r18
	pop r17
	pop r16
	ret

dump_hexs: push r18
dump_hexs_lp2: ldi r18,16
dump_hexs_lp1: ld r16,Y+
	rcall put_hex
	ldi r16,$20
	rcall putchar
	dec r17
	breq dump_hexsx
	dec r18
	brne dump_hexs_lp1
dump_hexsx: rcall put_nl
	tst r17
	brne dump_hexs_lp2
	rcall put_nl
	pop r18
	ret

put_nl: ldi r16,13
	rcall putchar
	ldi r16,10
	rjmp putchar

put_hex: push r16
	swap r16
	rcall put_hex1
	pop r16
put_hex1: andi r16,15
	cpi r16,10
	brcs put_hex2
	subi r16,-7
put_hex2: subi r16,-$30
	rjmp putchar
	.endif

;unfortunately I couldn't get the "screen peek" function on the T6963C to work (delivered somewhat skewed data)
;so I had to use a workaround converting the content of the first text line to graphics myself
screenshot_:
	ldi ZL,LOW(pic*2)
	ldi ZH,HIGH(pic*2)
	ldi YL,LOW(screenshot_tx*2)
	ldi YH,HIGH(screenshot_tx*2)
	lds r16,scrdmpno
	rcall z_init

	ldi ZL,LOW(pichdr*2)
	ldi ZH,HIGH(pichdr*2)
	ldi YL,LOW(gbuf)
	ldi YH,HIGH(gbuf)
	lpm r17,Z+
	push r17
scr_cp_phdr: lpm r16,Z+
	st Y+,r16
	dec r17
	brne scr_cp_phdr
	pop r17
	rcall zsend_packet

;convert text line to graphics data
	ldi r16,LOW(text_scr)
	rcall lcd_data
	ldi r16,HIGH(text_scr)
	rcall lcd_data
	ldi r16,$24				;set ADP
	rcall lcd_cmd
	rcall clr_gbuf
	ldi YL,LOW(gbuf)
	ldi YH,HIGH(gbuf)
	ldi r18,16
scrshot_lp1:
	ldi r16,$c1
	rcall lcd_cmd
	rcall lcd_status
	rcall lcd_status
	rcall lcd_read
	clt
	ldi ZL,LOW(sschr*2)
	ldi ZH,HIGH(sschr*2)
	clr r17
	tst r16
	breq scrshot1
	inc r17
	cpi r16,'.'-32
	breq scrshot1
	inc r17
	cpi r16,'m'-32
	breq scrshot1
	inc r17
	cpi r16,'n'-32
	breq scrshot1
	inc r17
	cpi r16,'s'-32
	breq scrshot1
	ldi ZL,LOW(chartab*2)
	ldi ZH,HIGH(chartab*2)
	ldi r17,$7f
	and r17,r16
	tst r16
	brmi scrshot1
	set
	ldi ZL,LOW(gchar*2)
	ldi ZH,HIGH(gchar*2)
	ldi r17,-$10
	add r17,r16
	ldi r16,7
	mul r16,r17
	mov r17,r0
	rjmp scrshot2
scrshot1: add r17,r17
	add r17,r17
	add r17,r17
scrshot2: add ZL,r17
	ldi r17,0
	adc ZH,r17
	ldi r17,8
	brtc scrshot3
	ldi r17,7
scrshot3: push YL
	push YH
scrshot_lp2: lpm r16,Z+
	brtc scrshot4
	lsr r16
	lsr r16
scrshot4: st Y,r16
	adiw YH:YL,16
	dec r17
	brne scrshot_lp2
	pop YH
	pop YL
	adiw YH:YL,1
	dec r18
	brne scrshot_lp1

	ldi r17,8*16
	rcall zsend_packet

;read out graphics screen
	ldi r16,LOW(graphic_scr+8*16)
	rcall lcd_data
	ldi r16,HIGH(graphic_scr+8*16)
	rcall lcd_data
	ldi r16,$24				;set ADP
	rcall lcd_cmd
	ldi r18,15
scrshot_lp3: ldi r17,8*16
	ldi YL,LOW(gbuf)
	ldi YH,HIGH(gbuf)
scrshot_lp4: ldi r16,$c1
	rcall lcd_cmd
	rcall lcd_status
	rcall lcd_status
	rcall lcd_read

;	ldi r16,$aa

	st Y+,r16
	dec r17
	brne scrshot_lp4
	ldi r17,8*16
	rcall zsend_packet
	dec r18
	brne scrshot_lp3
	ldi YL,LOW(scrdmpno)
	ldi YH,HIGH(scrdmpno)
	ldi ZL,LOW(zeofpic*2)
	ldi ZH,HIGH(zeofpic*2)
scrshot_x: rcall z_end
	ld r16,Y
	inc r16
	cpi r16,99
	brcs scrshot_x1
	clr r16
scrshot_x1: st Y,r16
	jmp main_loop

;send raw content of the trace buffer
trc_dmp_: ldi ZL,LOW(dmp*2)
	ldi ZH,HIGH(dmp*2)
	ldi YL,LOW(trcdmp_tx*2)
	ldi YH,HIGH(trcdmp_tx*2)
	lds r16,trdmpno
	rcall z_init
	ldi YL,LOW(trace)
	ldi YH,HIGH(trace)
	ldi r18,HIGH(trace_size)
trc_dmplp1: ldi r16,'.'-32
	rcall lcd_chr
	clr r17
	rcall zsend_packet1
	dec r18
	brne trc_dmplp1
	ldi r16,'.'-32
	rcall lcd_chr
	ldi r17,LOW(trace_size)
	rcall zsend_packet1
	ldi YL,LOW(trdmpno)
	ldi YH,HIGH(trdmpno)
	ldi ZL,LOW(zeofdmp*2)
	ldi ZH,HIGH(zeofdmp*2)
	rjmp scrshot_x

;this is a poor-man's ZMODEM
;expecting the risk of transmission errors is quite low on just a short cable towards receiving PC
;in fact, it only needs Tx and fires everything without waiting for acknowledgement, relying upon receiver will handle properly
z_init: push r16
	push ZL
	push ZH
	rcall wt_for_keyrel
	rcall clear_ascr
	ldi r16,$94			;text on
	rcall lcd_cmd
	clr r16				;text buffer address
	rcall lcd_data
	ldi r16,HIGH(alt_scr)
	rcall lcd_data
	ldi r16,$40			;set text home addess
	rcall lcd_cmd
	ldi ZL,LOW(sending_tx*2)
	ldi ZH,HIGH(sending_tx*2)
	rcall lcd_stralt
	movw ZH:ZL,YH:YL
	rcall lcd_stralt
	ldi r16,6*16
	rcall lcd_data
	ldi r16,HIGH(alt_scr)
	rcall lcd_ptr
	clr r16
	sts TIMSK2,r16
	ldi ZL,LOW(zrqinit*2)
	ldi ZH,HIGH(zrqinit*2)
	rcall zsend_str
	rcall zdelay
	ldi ZL,LOW(zfile*2)
	ldi ZH,HIGH(zfile*2)
	rcall zsend_str
	clr crcac1
	clr crcac2
	pop ZH
	pop ZL
	rcall zsend_str1
	pop r17
	inc r17
	ldi r16,'0'
zflnm_lp: subi r17,10
	brmi zflnm
	inc r16
	rjmp zflnm_lp
zflnm: subi r17,-(10+'0')
	push r17
	rcall putcharz
	pop r16
	rcall putcharz
	rcall zsend_str1
	ldi r17,$6b
	rcall zsend_datax
	ldi ZL,LOW(zdata*2)
	ldi ZH,HIGH(zdata*2)
	rjmp zsend_str

z_end: rcall zsend_str
	ldi ZL,LOW(zfin*2)
	ldi ZH,HIGH(zfin*2)
	rcall zsend_str
	ldi r18,3
zx_lp: ldi r16,10
zwt: rcall zdelay
	dec r16
	brne zwt
	ldi ZL,LOW(zend*2)
	ldi ZH,HIGH(zend*2)
	rcall zsend_str
	dec r18
	brne zx_lp
	clr r16				;text buffer address
	rcall lcd_data
	ldi r16,HIGH(text_scr)
	rcall lcd_data
	ldi r16,$40			;set text home addess
	rcall lcd_cmd
	ldi r16,$9c			;text & graphic on
	rcall lcd_cmd
	ldi r16,1<<OCIE2A
	sts TIMSK2,r16
	ret

zsend_packet: ldi YL,LOW(gbuf)
	ldi YH,HIGH(gbuf)
zsend_packet1: clr crcac1
	clr crcac2
zsend_plp: ld r16,Y+
	rcall putcharz
	dec r17
	brne zsend_plp
	ldi r17,$69
zsend_datax: ldi r16,$18
	rcall putchar
	mov r16,r17
	rcall putcharz
	mov r16,crcac1
	push crcac2
	rcall putcharz
	pop r16
	rjmp putcharz

zsend_str1: lpm r17,Z+
zsend_lp1: lpm r16,Z+
	rcall putcharz
	dec r17
	brne zsend_lp1
	ret

zsend_str: lpm r17,Z+
zsend_lp: lpm r16,Z+
	rcall putchar
	dec r17
	brne zsend_lp
	ret

putcharz: rcall crc16
	push r16
	andi r16,$7f
	breq putchar_esc		;0/$80 has obviously to be escaped for some ZMODEM receivers
	cpi r16,$0d
	breq putchar_esc
	cpi r16,$10
	breq putchar_esc
	cpi r16,$11
	breq putchar_esc
	cpi r16,$13
	breq putchar_esc
	cpi r16,$18
	breq putchar_esc
/*	cpi r16,$20				;use this if receiver insists that all control chars are to be escaped
	brcs putchar_esc */
	pop r16
putchar: push r18
	push r17
	ldi r17,11	;1+8+2 stop bit
	com r16
	sec			;Start bit
	cli
putchar0: brcc putchar1	;1	2	If carry set
	cbi PORTB,1			;1    	send a '0'
	rjmp putchar2		;2		else	
putchar1:
	sbi PORTB,1			;	1   send a '1'
	nop					;	1
putchar2:
	rcall UART_delay	;3  	One bit delay
	rcall UART_delay	;3
	lsr r16				;1		Get next bit
	dec r17				;1		If not all bit sent
	brne putchar0		;2	    send next
					;else
	sei
	pop r17
	pop r18
	ret				;   return

putchar_esc: ldi r16,$18
	rcall putchar
	pop r16
	ori r16,$40
	rjmp putchar


UART_delay:
	.if ser_speed==9600
	ldi r18,192			;1
	.endif
	.if ser_speed==57600
	ldi r18,29			;1
	.endif
UART_delay1: nop		;1
	dec r18				;1
	brne UART_delay1	;2
	rjmp PC+1
	ret					;4

zdelay:	clr r24
	clr r25
zdelay_lp: push r16
	ldi r16,10
zdelay_lp1: dec r16
	brne zdelay_lp1
	pop r16
	sbiw r25:r24,1
	brne zdelay_lp
	ret

.def crcac1=r14		;CRC low
.def crcac2=r15		;CRC high
.def crctmp1=r25
.def crctmp2=r24
;EmbDev.net
crc16:
; First XOR
	eor crcac1,r16
; Second XOR
	mov crctmp1,crcac1
	swap crctmp1
	andi crctmp1,15
	eor  crcac1,crctmp1
; Third XOR
	mov crctmp1,crcac1
	swap crctmp1
	andi crctmp1,$f0
	eor  crcac2,crctmp1
; Fourth XOR
	mov  crctmp1,crcac1
	swap crctmp1
	mov  crctmp2,crctmp1
	andi crctmp1,$f0
	andi crctmp2,15
	lsl crctmp1
	rol crctmp2
	eor crcac1,crctmp1
	eor crcac2,crctmp2
	mov crctmp1,crcac1
	mov crcac1,crcac2
	mov crcac2,crctmp1
	ret


eepr_get_prslot: ldi r17,dprefs
	ldi r18,-1
	clr ZL
	clr ZH
eepr_get_prslp: sbic EECR,EEPE
	rjmp eepr_get_prslp
	out EEARH,ZH
	out EEARL,ZL
	sbi EECR,EERE
	in r16,EEDR
	inc r16
	cp r16,r18
	breq eepr_get_prslotx
	mov r18,r16
	dec r18
	adiw ZH:ZL,prefsize
	dec r17
	brne eepr_get_prslp
	clr ZL
	clr ZH
eepr_get_prslotx: ret

eepr_save_prefs: ldi XL,LOW(tr_mode1)
	ldi XH,HIGH(tr_mode1)
	in r16,tr_mode
	andi r16,$3f
	sts tr_mode1,r16
	ldi r17,prefsize1
eepr_save_prlp1: sbic EECR,EEPE
	rjmp eepr_save_prlp1
	out EEARH,ZH
	out EEARL,ZL
	sbi EECR,EERE
	in r16,EEDR
	inc r16
eepr_save_prlp2: out EEDR,r16
	sbi EECR,EEMPE
	sbi EECR,EEPE
	adiw ZH:ZL,1
eepr_save_prwt: sbic EECR,EEPE
	rjmp eepr_save_prwt
	out EEARH,ZH
	out EEARL,ZL
	ld r16,X+
	dec r17
	brpl eepr_save_prlp2
	ret

load_chk_prefs: rcall eepr_load_prefs
	in r16,tr_mode
	cpi r16,-1
	brne load_chk_prefsx

	ldi XL,LOW(tr_mode1)
	ldi XH,HIGH(tr_mode1)
	ldi r17,prefsize1
	rcall clr_mem	
	out tr_mode,r16
	ldi r16,128
	sts lcd_pwm,r16
load_chk_prefsx: lds r16,lcd_pwm
	out OCR0A,r16	
	ret 

eepr_load_prefs: ldi XL,LOW(tr_mode1)
	ldi XH,HIGH(tr_mode1)
	ldi r17,prefsize1
	adiw ZH:ZL,1
eepr_load_prlp1: sbic EECR,EEPE
	rjmp eepr_save_prlp1
	out EEARH,ZH
	out EEARL,ZL
	sbi EECR,EERE
	in r16,EEDR
	st X+,r16
	adiw ZH:ZL,1
	dec r17
	brne eepr_load_prlp1
	lds r16,tr_mode1
	out tr_mode,r16
	ret

show_meas: tst r12
	breq show_measx
	lds r16,meas_lft
	rcall show_msln
	lds r16,meas_rgt
	rcall show_msln
show_measx: ret

	.include "features.asm"

.macro input1
	in r0,PINA
	st Y+,r0
.endmacro

.macro input10
	input1
	input1
	input1
	input1
	input1
	input1
	input1
	input1
	input1
	input1
.endmacro

.macro input100
	input10
	input10
	input10
	input10
	input10
	input10
	input10
	input10
	input10
	input10
.endmacro

.macro input1000
	input100
	input100
	input100
	input100
	input100
	input100
	input100
	input100
	input100
	input100
.endmacro

.macro inp16_1
	in r0,PINA
	in r3,PINC
	st Y+,r0
	st Y+,r3
.endmacro

.macro inp16_10
	inp16_1
	inp16_1
	inp16_1
	inp16_1
	inp16_1
	inp16_1
	inp16_1
	inp16_1
	inp16_1
	inp16_1
.endmacro

.macro inp16_100
	inp16_10
	inp16_10
	inp16_10
	inp16_10
	inp16_10
	inp16_10
	inp16_10
	inp16_10
	inp16_10
	inp16_10
.endmacro

.macro inp16_1000
	inp16_100
	inp16_100
	inp16_100
	inp16_100
	inp16_100
	inp16_100
	inp16_100
	inp16_100
	inp16_100
	inp16_100
.endmacro

arm_break:
	clr r16
	sts TIMSK2,r16
	cli
	ldi r16,-1
	out PORTD,r16
	clr r16
	out DDRD,r16
	sbi PORTB,PB5
	cbi DDRB,PB5
	cbi PORTB,PB4
	clr r16
	sts EICRA,r16		;falling edge trigger
	ldi r16,1<<INT1
	out EIMSK,r16
	ldi r16,7
	out EIFR,r16
	sei
	ret

disarm_break: sbi PORTB,PB4
	sbi DDRB,PB5
	clr r16
	out EIMSK,r16
	ret

trc_clr_mem: ldi XL,LOW(trace)
	ldi XH,HIGH(trace)
	ldi r24,LOW(trace_size)
	ldi r25,HIGH(trace_size)
	clr r16
trc_clr_mlp: st X+,r16
	sbiw r25:r24,1
	brne trc_clr_mlp
	ret

trc8_pr_tbl:
	rjmp trc8_full_pre1
	rjmp trc8_05us_pr
	rjmp trc8_1us_pr
	rjmp trc8_2us_pr
	rjmp trc8_5us_pr
	rjmp trc8_10us_pr
	rjmp trc8_20us_pr
	rjmp trc8_50us_pr
	rjmp trc8_100us_pr
	rjmp trc8_200us_pr
	rjmp trc8_500us_pr
	rjmp trc8_1ms_pr
	rjmp trc8_2ms_pr
	rjmp trc8_5ms_pr
	rjmp trc8_10ms_pr
	rjmp trc8_20ms_pr
	rjmp trc8_50ms_pr
	rjmp trc8_100ms_pr
	rjmp trc8_200ms_pr
	rjmp trc8_500ms_pr

trc16_pr_tbl:
	rjmp trc16_full_pre1j
	rjmp trc16_05us_pr
	rjmp trc16_1us_pr
	rjmp trc16_2us_pr
	rjmp trc16_5us_pr
	rjmp trc16_10us_pr
	rjmp trc16_20us_pr
	rjmp trc16_50us_pr
	rjmp trc16_100us_pr
	rjmp trc16_200us_pr
	rjmp trc16_500us_pr
	rjmp trc16_1ms_pr
	rjmp trc16_2ms_pr
	rjmp trc16_5ms_pr
	rjmp trc16_10ms_pr
	rjmp trc16_20ms_pr
	rjmp trc16_50ms_pr
	rjmp trc16_100ms_pr
	rjmp trc16_200ms_pr
	rjmp trc16_500ms_pr

trc8_po_tbl:
	rjmp trc8_full_po
	rjmp trc8_05us_po
	rjmp trc8_1us_po
	rjmp trc8_2us_po
	rjmp trc8_5us_po
	rjmp trc8_10us_po
	rjmp trc8_20us_po
	rjmp trc8_50us_po
	rjmp trc8_100us_po
	rjmp trc8_200us_po
	rjmp trc8_500us_po
	rjmp trc8_1ms_po
	rjmp trc8_2ms_po
	rjmp trc8_5ms_po
	rjmp trc8_10ms_po
	rjmp trc8_20ms_po
	rjmp trc8_50ms_po
	rjmp trc8_100ms_po
	rjmp trc8_200ms_po
	rjmp trc8_500ms_po

trc16_po_tbl:
	rjmp trc16_full_po
	rjmp trc16_05us_po
	rjmp trc16_1us_po
	rjmp trc16_2us_po
	rjmp trc16_5us_po
	rjmp trc16_10us_po
	rjmp trc16_20us_po
	rjmp trc16_50us_po
	rjmp trc16_100us_po
	rjmp trc16_200us_po
	rjmp trc16_500us_po
	rjmp trc16_1ms_po
	rjmp trc16_2ms_po
	rjmp trc16_5ms_po
	rjmp trc16_10ms_po
	rjmp trc16_20ms_po
	rjmp trc16_50ms_po
	rjmp trc16_100ms_po
	rjmp trc16_200ms_po
	rjmp trc16_500ms_po

trc16_full_pre1j: jmp trc16_full_pre1

	.include "trace.asm"

trc_prep: tst r1
	breq trc_prepx
trc_prep1: in r0,PINA
	and r0,r1
	cp r0,r2
	breq trc_prep1
trc_prepx: ret


start_trace: call clear_allscr
	ldi ZL,LOW(menu2*2)
	ldi ZH,HIGH(menu2*2)
	call build_menu
	call lcd_menu
	call wt_for_keyrel
	rcall arm_break
	rcall trc_set_fspeed
	rcall trc_clr_mem
	ldi YL,LOW(trace)
	ldi YH,HIGH(trace)
	lds r1,tr_mask1
	lds r2,trigger1
	sbic tr_mode,0
	rjmp trc_com
	ldi r20,LOW(trace+trace_size)
	ldi r21,HIGH(trace+trace_size)
	ldi ZL,LOW(trc8_pr_tbl)
	ldi ZH,HIGH(trc8_pr_tbl)
	rjmp trc_com1
trc_com: movw r21:r20,YH:YL
	ldi ZL,LOW(trc8_po_tbl)
	ldi ZH,HIGH(trc8_po_tbl)
	tst r1			;any trigger input defined?
	brne trc_com1	;yes, skip
	com r2			;no, set trigger condition to never matching
trc_com1: ldi r24,LOW(trace_size)
	ldi r25,HIGH(trace_size)
	sbis tr_mode,1
	rjmp trc_po8
	adiw ZH:ZL,trc16_po_tbl-trc8_po_tbl
	ldi r24,LOW(trace_size/2)
	ldi r25,HIGH(trace_size/2)
trc_po8: movw r23:r22,r25:r24
	lds r16,sclk
	add ZL,r16
	ldi r16,0
	adc ZH,r16
	ijmp

trc8_full_po: ldi ZL,LOW(trc_rst)
	ldi ZH,HIGH(trc_rst)
	sts PCMSK0,r1
	ldi r16,1<<PCIE0
	rcall trc_prep
	out PCIFR,r16
	sts PCICR,r16
	in r0,PINA
	ijmp

trc16_full_po: ldi ZL,LOW(trc16_rst)
	ldi ZH,HIGH(trc16_rst)
	sts PCMSK0,r1
	ldi r16,1<<PCIE0
	rcall trc_prep
	out PCIFR,r16
	sts PCICR,r16
	in r0,PINA
	in r3,PINC
	ijmp

trc_post_chk: cpi YL,LOW(trace+trace_size)
	cpc YH,r16
	brcs trc_post_chkx
	ldi YL,LOW(trace)
	ldi YH,HIGH(trace)
trc_post_chkx: ret

trc_post_trig: cli
	ldi r16,$ff
	sbic tr_mode,1
	ldi r16,$fe
	and YL,r16
	ldi r16,HIGH(trace+trace_size)
	rcall trc_post_chk
	st Y+,r0
	rcall trc_post_chk
	sbis tr_mode,1
	rjmp trc_post_end
	st Y+,r3
	rcall trc_post_chk
trc_post_end: cli
	clr r16
	sts PCICR,r16
	pop r16
	pop r16
trc_post_end1: rcall disarm_break
	movw r25:r24,YH:YL
trc_post_cplp:
	ldi r18,LOW(blsize)
	ldi YL,LOW(trace+trace_size-blsize)
	ldi YH,HIGH(trace+trace_size-blsize)
	cp r24,YL
	cpc r25,YH
	brcs trc_post_end2
	ldi r18,LOW(trace+trace_size)
	sub r18,r24
	movw YH:YL,r25:r24
trc_post_end2: push r18
	movw r23:r22,YH:YL
	ldi XL,LOW(line)
	ldi XH,HIGH(line)
trc_post_cplp1: ld r16,Y+
	st X+,r16
	dec r18
	brne trc_post_cplp1
	push XL
	push XH
	movw XH:XL,r23:r22
	ldi r17,HIGH(trace+1)
trc_post_cplp2: ld r16,-X
	st -Y,r16
  	cpi XL,LOW(trace+1)
	cpc XH,r17
	brcc trc_post_cplp2
	pop XH
	pop XL
	pop r18
trc_post_cplp3: ld r16,-X
	st -Y,r16
	dec r18
	brne trc_post_cplp3
	ldi r16,LOW(blsize)
	ldi r17,HIGH(blsize)
	add r24,r16
	adc r25,r17
	ldi r16,HIGH(trace+trace_size)
	cpi r24,LOW(trace+trace_size)
	cpc r25,r16
	brcs trc_post_cplp
	rcall trc_set_clock
	call get_tscale
	tst r16
	brpl trc_post_end3
	lds r16,tscale
	neg r16
	ldi ZL,LOW(time_div*2-1)
	ldi ZH,HIGH(time_div*2-1)
	add ZL,r16
	ldi r16,0
	adc ZH,r16
	lpm r0,Z
	clr r1
	rjmp trc_post_end4
trc_post_end3: ldi r17,128
	mul r16,r17
trc_post_end4: ldi r16,LOW(trace_size)
	sbic tr_mode,1
	ldi r16,LOW(trace_size/2)
	ldi r17,HIGH(trace_size)
	sbic tr_mode,1
	ldi r17,HIGH(trace_size/2)
	sub r16,r0
	sbc r17,r1
	sts trace_offset,r16
	sts trace_offset+1,r17
	call wt_for_keyrel
	jmp restart

trc_set_fspeed: ldi r16,$80
	ldi r17,0
	sts CLKPR,r16
	sts CLKPR,r17			;set full speed 
	ret

trc_set_clock: ldi r16,$80
	ldi r17,1
	sts CLKPR,r16
	sts CLKPR,r17
	ldi r16,1<<OCIE2A
	sts TIMSK2,r16
	sei
	ret

trc_end: cli
	rcall disarm_break
	rcall trc_set_clock
	clr r16
	sts trace_offset,r16
	sts trace_offset+1,r16
	call wt_for_keyrel
	jmp restart

trc8_full_pre1:
	ldi ZL,LOW(trc_end)
	ldi ZH,HIGH(trc_end)
	call trc_prep
trc_wait2: mov r3,r1
	in r0,PINA
	and r3,r0
	cpse r3,r2
	rjmp trc_wait2
trc_rst: st Y+,r0
	#ifdef _M1284PDEF_INC_
	.if test==0
	input1000
	input1000
	input1000
	input1000
	input1000
	input1000
	input1000
	input1000
	input1000
	input1000
	input1000
	input1000
	input1000
	input1000
	.endif
	input100
	input100
	input100
	input100
	input100
	#endif
	#ifdef _M644PADEF_INC_
	.if test==0
	input1000
	input1000
	input1000
	.endif
	#endif
	input100
	input100
	input100
	input100
	input10
	input10
	input10
	input10
	input10
	input10
	input10
	input10
	input10
	input1
	input1
	input1
	input1
	input1
	input1
	input1
	input1
	input1
	in r0,PINA
	movw YH:YL,r21:r20
	ijmp

trc16_full_pre1:
	ldi ZL,LOW(trc_end)
	ldi ZH,HIGH(trc_end)
	call trc_prep
trc16_wait2: mov r4,r1
	in r0,PINA
	in R3,PINC
	and r4,r0
	cpse r4,r2
	rjmp trc16_wait2
trc16_rst: st Y+,r0
	st Y+,r3
	#ifdef _M1284PDEF_INC_
	.if test==0
	inp16_1000
	inp16_1000
	inp16_1000
	inp16_1000
	inp16_1000
	inp16_1000
	inp16_1000
	inp16_100
	inp16_100
	inp16_100
	inp16_100
	.endif
	inp16_10
	inp16_10
	inp16_10
	inp16_10
	inp16_10
	#endif
	#ifdef _M644PADEF_INC_
	.if test==0
	inp16_1000
	inp16_100
	inp16_100
	inp16_100
	inp16_100
	inp16_100
	.endif
	inp16_100
	inp16_100
	#endif
	inp16_10
	inp16_10
	inp16_10
	inp16_10
	inp16_1
	inp16_1
	inp16_1
	inp16_1
	inp16_1
	inp16_1
	inp16_1
	inp16_1
	inp16_1
	in r0,PINA
	in r3,PINC
	movw YH:YL,r21:r20
	ijmp

	.dseg
	.org SRAM_START
trace:		.byte trace_size
kstate:		.byte 1
kstate1:	.byte 1
keys:		.byte 1
tkeys:		.byte 1
dbnce:		.byte 1
cnstate1:	.byte 1
cnt1:		.byte 1
cnstate2:	.byte 1
cnt2:		.byte 1
scrdmpno:	.byte 1
trdmpno:	.byte 1
trace_offset: .byte 2
ser_offset:	.byte 2
tscale:		.byte 1
prefno:		.byte 1
tr_mode1:	.byte 1
sclk:		.byte 1
tr_mask1:	.byte 1
trigger1:	.byte 1
lcd_pwm:	.byte 1
inp_def:	.byte 16
meas_lft:	.byte 1
meas_rgt:	.byte 1
ser_base:	.byte 32
gbuf:		.byte 160
line:		.byte 256


