
trc_sh_spc:
	rjmp show_nib_
	rjmp show_i2c
	rjmp show_spi_rm
	rjmp show_spi_fm
	rjmp show_spi_rl
	rjmp show_spi_fl
;show serial handeled in calling proc

show_nib_:
	push r19
	push r20
	push r22		
	mov r16,r20
	andi r16,15
	breq show_nib_1
	ldi r22,0
	rjmp show_nib_2
show_nib_1: ldi r22,1
show_nib_2: rcall show_nib
	pop r22
	pop r20
	pop r19
show_nib_x: subi r21,-10
	lsl	r20
	lsl r20
	lsl r20
	ldi r16,4
	add r14,r16
	ret

show_nib: rcall clr_gbuf
	rcall get_tscale
	clt
	mov r20,r16			;timescale
	ldi XL,LOW(trace)
	ldi XH,HIGH(trace)
	lds r2,trace_offset
	lds r3,trace_offset+1
	ldi r17,0			;x-offset
	sbis tr_mode,1
	rjmp show_nib0
	add r2,r2
	adc r3,r3
	add XL,r15
	adc XH,r17
show_nib0: add XL,r2
	adc XH,r3
	ldi YL,LOW(line)
	ldi YH,HIGH(line)
	ldi r19,-1
show_nblp1:
	ld r16,X
	tst r22
	breq show_nib1
	swap r16
show_nib1: andi r16,15
	cp r16,r19
	breq show_nib2
	mov r19,r16
	st Y+,r17
	st Y+,r16
show_nib2: tst r20
	brmi show_nib3
	clr r16
	add XL,r20
	adc XH,r16
	sbis tr_mode,1
	rjmp show_nib4
	add XL,r20
	adc XH,r16
	rjmp show_nib4
show_nib3: adiw XH:XL,1
	sbic tr_mode,1
	adiw XH:XL,1
	mov r16,r20
	neg r16
	add r17,r16
	brpl show_nib5
	ldi r17,127
show_nib4: inc r17
show_nib5: cpi r17,128
	brne show_nblp1
	ldi r17,127
	st Y,r17
	movw r25:r24,YH:YL
	ldi YL,LOW(line)
	ldi YH,HIGH(line)
show_nblp2: cp r24,YL
	cpc r25,YH
	brne show_nib6
	rcall show_meas
	rjmp send_gbuf2

show_nib6: ld r17,Y
	ldd r19,Y+2
	sub r19,r17
	breq show_nib11
	cpi r19,8
	brcc show_nib7
	mov r16,r19
	subi r16,-18
	rcall pr_gchr
	add r17,r19
	rjmp show_nib11
show_nib7: ldi r16,16
	rcall pr_gchr
	subi r19,5
	cpi r19,6
	brcs show_nib8
	push r19
	push r17
	lsr r19
	add r17,r19
	dec r17
	ldd r16,Y+1
	rcall pr_gchr
	pop r17
	pop r19
show_nib8: push r17
	subi r17,-4
	subi r19,2
show_nblp3: ldi r16,18
	rcall pr_gchr
	inc r17
	dec r19
	brne show_nblp3
show_nib10: pop r17
	ldd r16,Y+2
	subi r16,4
	subi r17,-3
	cp r17,r16
	brcc show_nib11
	mov r17,r16
	ldi r16,17
	rcall pr_gchr
show_nib11: adiw YH:YL,2
	rjmp show_nblp2

;copy a character to graphics buffer
;r16  character
;		0-15	hex chars 0-9,A-F
;		16-		special characters & symbols
;	  non-inverted value: use 8x9 font
;	  inverted value (one's complement): use 8x7 font (needed for serial lines in 16 line mode)
;r17  X position
;T flag cleared: normal character display
;T flag set: inverted character display
pr_gchr: push YL
	push YH
	push r17
	push r18
	push r19
	ldi r18,7
	and r18,r17
	clr r0
	asr r17
	asr r17
	asr r17
	sbrc r17,7
	dec r0
	cpi r17,16
	brge pr_gchrx1
	cpi r17,-1
	brlt pr_gchrx1
	clr r19
	cpi r17,0
	brge pr_gchr1
	ori r19,1
	rjmp pr_gchr2
pr_gchrx1: rjmp pr_gchrx
pr_gchr1: cpi r17,15
	brlt pr_gchr2
	ori r19,2
pr_gchr2: ldi YL,LOW(gbuf+16)
	ldi YH,HIGH(gbuf+16)
	add YL,r17
	adc YH,r0
	tst r16
	brpl pr_gchr3
	com r16
	ldi r17,5
	ldi ZL,LOW(gcharm*2)
	ldi ZH,HIGH(gcharm*2)
	cpi r16,16
	brcs pr_gchr4
	ldi r17,7
	sbiw YH:YL,16
	ldi ZL,LOW(gcharmb*2)
	ldi ZH,HIGH(gcharmb*2)
	subi r16,16
	rjmp pr_gchr4
pr_gchr3: ldi r17,7
	ldi ZL,LOW(gchar*2)
	ldi ZH,HIGH(gchar*2)
	cpi r16,16
	brcs pr_gchr4
	sbiw YH:YL,16
	ldi ZL,LOW(gcharb*2)
	ldi ZH,HIGH(gcharb*2)
	subi r16,16
	ldi r17,9
pr_gchr4: mul r16,r17
	add ZL,r0
	adc ZH,r1
	clr r16
	brtc pr_gchr5
	ldi r16,0b11111110
pr_gchr5: mov r3,r16
pr_gchr_lp1: clr r1
	lpm r0,Z+
	eor r0,r3
	mov r2,r18
pr_gchr_lp2: dec r2
	brmi pr_gchr6
	lsr r0
	ror r1
	rjmp pr_gchr_lp2
pr_gchr6: ld r16,Y
	or r16,r0
	sbrs r19,0
	st Y,r16
	ldd r16,Y+1
	or r16,r1
	sbrs r19,1
	std Y+1,r16
	adiw YH:YL,16
	dec r17
	brne pr_gchr_lp1
pr_gchrx: pop r19
	pop r18
	pop r17
	pop YH
	pop YL
	ret

show_ser_: 
	push r15
	push r19
	push r24
	push r25
	push r12
	push r14
	mov r16,r14
	rcall ser_ev_line
	pop r14
	pop r12
	push r12
	push r14
	clr r11
	sbic tr_mode,1
	com r11
	rcall show_ser
	pop r14
	pop r12
	pop r25
	pop r24
	pop r19
	pop r15
	subi r21,-8
	sbis tr_mode,1
	subi r21,-2
	inc r14
	ret

show_ser: push r12
	push r14
	rcall clr_gbuf
	rcall get_tscale
	mov r19,r16
	ldi XL,LOW(trace)
	ldi XH,HIGH(trace)
	lds r14,trace_offset
	lds r15,trace_offset+1
	lds r0,ser_offset
	lds r1,ser_offset+1
	sub r14,r0
	sbc r15,r1
	sbic tr_mode,1
	add r14,r14
	sbic tr_mode,1
	adc r15,r15
	add XL,r14
	adc XH,r15
	clr r16
	clr r17
	clr r18
	tst r19
	brpl show_ser_lp2
	mov r12,r19
	neg r12
	ldi r16,-1
show_ser_lp1: add r0,r16
	adc r1,r16
	brcc show_ser1
	sub r17,r12
	sbci r18,0
	rjmp show_ser_lp1
show_ser_lp2: sub r0,r19
	sbc r1,r16
	brcs show_ser1
	subi r17,1
	sbci r18,0
	rjmp show_ser_lp2
show_ser1: pop r16
	sbrc r16,3
	adiw XH:XL,1
	ldi YL,LOW(line)
	ldi YH,HIGH(line)
	ld r15,Y
	ldd r14,Y+1
	clr r13
	clt
show_ser_lp3: cp XL,r14
	cpc XH,r15
	brge show_ser2
	tst r13
	brmi show_ser6
	ldi r16,26
	sbrc r11,0
	ldi r16,~18
	sbrs r18,7
	rcall pr_gchr
	rjmp show_ser6
show_ser2: ldd r16,Y+3
	andi r16,$40
	breq show_ser3
	ldd r16,Y+4
	rcall pr_gchr
	rjmp show_ser5
show_ser3: ldi r16,19
	sbrc r11,0
	ldi r16,~17
	sbrs r18,7
	rcall pr_gchr
	com r13
	brpl show_ser4
	ldd r24,Y+2
	ldd r25,Y+3
	andi r25,$3f
	sbic tr_mode,1
	add r24,r24
	sbic tr_mode,1
	adc r25,r25
	add r14,r24
	adc r15,r25
	mov r24,r17
	mov r25,r18
	rjmp show_ser_lp3
show_ser4: push r17
	rcall show_ser_data
	pop r17
show_ser5:	adiw YH:YL,5
	ld r15,Y
	ldd r14,Y+1
show_ser6: tst r19
	brmi show_ser7
	mov r16,r19
	sbic tr_mode,1
	add r16,r16
	add XL,r16
	ldi r16,0
	adc XH,r16
	rjmp show_ser8
show_ser7: dec r12
	brne show_ser8
	mov r12,r19
	neg r12
	adiw XH:XL,1
	sbic tr_mode,1
	adiw XH:XL,1
show_ser8: subi r17,-1
	sbci r18,-1
	brmi show_ser_lp3
	cpi r17,128
	breq show_serx
	ldi r16,18
	sbrc r11,0
	ldi r16,~16
	sbrc r13,7
	rcall pr_gchr
	rjmp show_ser_lp3
show_serx: sbrc r13,7
	rcall show_ser_data
	pop r12
	rcall show_meas
	rjmp send_gbuf2

show_ser_data: tst r18
	brmi show_ser_datax
	tst r25
	brpl show_ser_data1
	clr r24
show_ser_data1: sub r17,r24
	lsr r17
	cpi r17,6
	brcs show_ser_datax
	add r17,r24
	subi r17,6
	ldd r16,Y+3
	bst r16,7
	ldd r16,Y+4
	swap r16
	andi r16,15
	eor r16,r11
	rcall pr_gchr
	subi r17,-6
	ldd r16,Y+4
	andi r16,15
	eor r16,r11
	rcall pr_gchr
	clt
show_ser_datax: ret

;r20 - bit mask
ser_base_ev: 
	ldi XL,LOW(line)
	ldi XH,HIGH(line)
	clr r17
	rcall clr_mem
	ldi r24,LOW(trace_size)
	ldi r25,HIGH(trace_size)
	sbic tr_mode,1
	ldi r24,LOW(trace_size/2)
	sbic tr_mode,1
	ldi r25,HIGH(trace_size/2)
	clr r19
	ld r17,Y
	and r17,r20
	clr XL
	clr XH
se_time_lp1: ld r16,Y+
	sbic tr_mode,1
	adiw YH:YL,1
	and r16,r20
	cp r16,r17
	breq se_time1
	mov r17,r16
	rcall list_srt_cnt
	clr XL
	clr XH
se_time1: adiw XH:XL,1
	sbiw r25:r24,1
	brne se_time_lp1

;find most frequent element

	ldi YL,LOW(line)
	ldi YH,HIGH(line)
	mov r0,r19
	inc r0
	clr r17
	clr r18
list_get_maxlp: ldd r16,Y+2
	cp r16,r17
	ldd r16,Y+3
	cpc r16,r18
	brcs list_get_max1
	ldd r17,Y+2
	mov r18,r16
list_get_max1: adiw YH:YL,4
	dec r0
	brne list_get_maxlp

;find lowest element at least half as much occurring as the most frequent element

	ldi YL,LOW(line)
	ldi YH,HIGH(line)
	clr r0
	lsr r18
	ror r17
list_get_oblenlp: ldd r1,Y+2
	cp r1,r17
	ldd r2,Y+3
	cpc r2,r18
	brcs list_get_oblnxt
;check if the next element is even more occurring as this one
	ldd r16,Y+6
	cp r16,r1
	ldd r16,Y+7
	cpc r16,r2
	brcs list_get_oblen1
	adiw YH:YL,4
list_get_oblen1:
	sbiw YH:YL,4
;calculate an average of the identified element and its predecessor/successor
	clr r4
	clr r5
	clr r6
	clr r7
	clr r8
	clr r9
	rcall ev_elem
	rcall ev_elem
	rcall ev_elem
;divide the sum of products by the sum of occurences
;result is four bits shifted left to retain fractional bits
	ldi r16,32
	clr r0
	clr r1
div32_lp: lsl r4   
	rol r5
	rol r6
	rol r7
	rol r0
	rol r1
	brcs div32_1
	cp r0,r8
	cpc r1,r9
	brcs div32_2
div32_1: inc r4
	sub r0,r8
	sbc r1,r9
div32_2: dec r16
	brne div32_lp
	movw r15:r14,r5:r4
	ldi r16,$7f
	and r15,r16
	rjmp list_get_oblenx
list_get_oblnxt: adiw YH:YL,4
	inc r0
	cp r0,r19
	brcs list_get_oblenlp
	clr r14
	clr r15
list_get_oblenx: ret

ev_elem: ld r12,Y
	ldd r13,Y+1
	ldd r14,Y+2
	ldd r15,Y+3
	add r8,r14
	adc r9,r15
;both factors are two times shifted left to get a fractional result in the end
	add r12,r12
	adc r13,r13
	add r12,r12
	adc r13,r13
	add r14,r14
	adc r15,r15
	add r14,r14
	adc r15,r15
 	mul r12,r14
    add r4,r0
    adc r5,r1
    mul r12,r15
    add r5,r0
    adc r6,r1
    mul r13,r14
    add r5,r0
    adc r6,r1
    mul r13,r15
    add r6,r0
    adc r7,r1
	adiw YH:YL,4
	ret

;insert element into ascending sorted list
list_srt_cnt: clr r0
	ldi ZL,LOW(line)
	ldi ZH,HIGH(line)
	tst r19
	breq list_srt_cnt_ins1
list_srt_cnt_srch:
	ld r16,Z
	cp r16,XL
	ldd r16,Z+1
	cpc r16,XH
	breq list_srt_cnt_inc
	in r1,SREG
	cp r0,r19
	breq list_srt_cnt_ins1
	sbrs r1,0					;previous carry flag
	rjmp list_srt_cnt_move
	adiw ZH:ZL,4
	inc r0
	rjmp list_srt_cnt_srch
list_srt_cnt_move: mov r1,r19
	mov r16,r19
	cpi r19,63
	breq list_srt_cnt_move1
	inc r19
list_srt_cnt_move1: add r16,r16
	add r16,r16
	ldi ZL,LOW(line-4)
	ldi ZH,HIGH(line-4)
	add ZL,r16
	ldi r16,0
	adc ZH,r16
list_srt_cnt_mvlp: ld r16,Z
	std Z+4,r16
	ldd r16,Z+1
	std Z+5,r16
	ldd r16,Z+2
	std Z+6,r16
	ldd r16,Z+3
	std Z+7,r16
	dec r1
	cp r1,r0
	breq list_srt_cnt_ins2
	sbiw ZH:ZL,4
	rjmp list_srt_cnt_mvlp
list_srt_cnt_inc: ldd XL,Z+2
	ldd XH,Z+3
	adiw XH:XL,1
	std Z+2,XL
	std Z+3,XH
	ret
list_srt_cnt_ins1: cpi r19,63
	breq list_srt_cnt_insx
	inc r19
list_srt_cnt_ins2: st Z+,XL
	st Z+,XH
	ldi r16,1
	st Z+,r16
	clr r16
	st Z,r16
list_srt_cnt_insx: ret

;r15 line offset (16 lines mode)
;r16 line
;r17 line mode
ser_ev_line: 
	ldi ZL,LOW(ser_md_tab*2-ser_modes)
	ldi ZH,HIGH(ser_md_tab*2-ser_modes)
	add ZL,r17
	ldi r17,0
	add ZH,r17
	lpm r12,Z			;ser_mode
	ldi XL,LOW(ser_base)
	ldi XH,HIGH(ser_base)
	add r16,r16
	add XL,r16
	ldi r16,0
	adc XH,r16
	ld r14,X+
	ld r17,X
	andi r17,$7f
	lds r10,trace_offset
	lds r11,trace_offset+1

	ldi r16,3
	and r16,r12
	sbrc r12,2
	inc r16
	subi r16,-7
	mul r16,r14
	movw r3:r2,r1:r0
	mul r16,r17
	add r3,r0
	movw r1:r0,r3:r2
	rcall shift_4right
	movw r3:r2,r1:r0
	movw r5:r4,r3:r2
	rcall get_tscale
	tst r16
	brmi ser_evlnp1
	mul r16,r2
	movw r5:r4,r1:r0
	mul r16,r3
	add r5,r0
ser_evlnp1: sts ser_offset,r4
	sts ser_offset+1,r5
	sub r10,r4
	sbc r11,r5
	brcc ser_evlnp2
	clr r10
	clr r11
ser_evlnp2: ldi ZL,LOW(trace)
	ldi ZH,HIGH(trace)
	movw YH:YL,ZH:ZL
	sbis tr_mode,1
	rjmp ser_evlnp3
	add r10,r10
	adc r11,r11
	sbrc r15,0
	adiw YH:YL,1
ser_evlnp3: mov r15,r17
	add ZL,r10
	adc ZH,r11
	ldi XL,LOW(line)
	ldi XH,HIGH(line)
	mov r16,r15
	mov r13,r14
	mov r1,r16
	mov r0,r13
	rcall shift_4right
	mov r13,r0
	lsr r13					;half bit duration
	movw r11:r10,r15:r14
	ldi r16,3
	and r16,r12
	sbrc r12,2
	inc r16
	subi r16,-5
ser_evlnp_lp1: add r10,r14
	adc r11,r15
	dec r16
	brne ser_evlnp_lp1
	movw r1:r0,r11:r10
	rcall shift_4right
	movw r11:r10,r1:r0
	ldi r16,-1
	sbis tr_mode,1
	rjmp ser_evlnp4
	add r10,r10
	adc r11,r11
	add r14,r14
	adc r15,r15
	ldi r16,$fe
ser_evlnp4: mov r8,r16
	mov r16,r12
	com r16
	andi r16,3
	clr r9
	sec
ser_evlnp_lp2: ror r9
	dec r16
	brpl ser_evlnp_lp2
	clt
ser_evln_lp: rcall ser_get
	breq ser_evlnx
	ldi r17,1
	add r0,r17
	ldi r17,0
	adc r1,r17
	add r4,r14
	adc r5,r15
	lsr r5
	ror r4
	lsr r5
	ror r4
	lsr r5
	ror r4
	lsr r5
	ror r4
	sbic tr_mode,1
	lsr r5
	sbic tr_mode,1
	ror r4
	movw r3:r2,r1:r0
	add r2,r4
	adc r3,r5
	add r2,r13
	adc r3,r17
	cp ZL,r2
	cpc ZH,r3
	brcc ser_evln_lp
	add r4,r13
	adc r5,r17
	bld r5,7
	st X+,r1
	st X+,r0
	st X+,r4
	st X+,r5
	st X+,r16
	ldi r16,HIGH(line+251)
	cpi XL,LOW(line+251)
	cpc XH,r16
	brcs ser_evln_lp
ser_evlnx: ldi r16,$7f
	st X,r16
	ret

ser_get:
ser_get_lp1:
	ldi r16,HIGH(trace+trace_size-1)
	sbic tr_mode,1
	ldi r16,HIGH(trace+trace_size-2)
	cpi YL,LOW(trace+trace_size-1)
	sbic tr_mode,1
	cpi YL,LOW(trace+trace_size-2)
	cpc YH,r16
	brcc ser_getx1
	ld r17,Y
	sbrc r12,7
	com r17
	and r17,r20
	brne ser_get_nxt
	ldd r17,Y+1
	sbic tr_mode,1
	ldd r17,Y+2
	sbrc r12,7
	com r17
	and r17,r20
	breq ser_get_nxt
	movw r1:r0,YH:YL
	clr r16
	add YL,r13
	adc YH,r16
	sbic tr_mode,1
	add YL,r13
	sbic tr_mode,1
	adc YH,r16
	ldi r16,HIGH(trace+trace_size)
	cpi YL,LOW(trace+trace_size)
	cpc YH,r16
	brcc ser_getx1
	ld r17,Y
	sbrc r12,7
	com r17
	and r17,r20
	brne ser_get1
ser_get_nxt1: movw YH:YL,r1:r0
ser_get_nxt: adiw YH:YL,1
	sbic tr_mode,1
	adiw YH:YL,1
	rjmp ser_get_lp1
ser_getx2: pop r16
	pop r16
ser_getx1: sez
	ret
ser_get1: push YL
	push YH
	add YL,r10
	adc YH,r11
	ldi r16,HIGH(trace+trace_size)
	cpi YL,LOW(trace+trace_size)
	cpc YH,r16
	brcc ser_getx2
	ld r17,Y
	sbrc r12,7
	com r17
	pop YH
	pop YL
	and r17,r20
	brne ser_get_nxt1
	mov r16,r9
	movw r2:r3,YH:YL
	clr r4
	clr r5
ser_get_lp2: rcall ser_nxt_bit
	clc
	breq ser_get2
	sec
ser_get2: ror r16
	brcc ser_get_lp2
	ldi r17,3
	eor r17,r12
	andi r17,3
ser_get_shft: dec r17
	brmi ser_get3
	lsr r16
	rjmp ser_get_shft
ser_get3: sbrs r12,2
	rjmp ser_getx
	rcall ser_nxt_bit
	clt
	breq ser_getx
	set
ser_getx: clz
	ret

ser_nxt_bit: add r4,r14
	adc r5,r15
	movw YH:YL,r4:r5
	lsr YH
	ror YL
	lsr YH
	ror YL
	lsr YH
	ror YL
	lsr YH
	ror YL
	and YL,r8
	add YL,r2
	adc YH,r3
	ld r17,Y
	sbrs r12,7
	com r17
	and r17,r20
	ret

ser_md_tab: .db $83,$87,$82,$86,$81,$85,$80,$84,3,7,2,6,1,5,0,4


show_spi_rm: clr r16
	clr r17
	rjmp show_spi
show_spi_fm: ldi r16,-1
	clr r17
	rjmp show_spi
show_spi_rl: clr r16
	ldi r17,-1
	rjmp show_spi
show_spi_fl: ldi r16,-1
	ldi r17,-1
show_spi: mov r9,r16
	mov r10,r17
	rcall spi_ev_mosi
	push r14
	push r15
	push r19
	push r24
	push r25
	clr r11
	rcall show_ser
	pop r25
	pop r24
	pop r19
	pop r15
	pop r14
	subi r21,-10
	rcall spi_ev_miso
	push r14
	push r15
	push r19
	push r24
	push r25
	clr r11
	rcall show_ser
	pop r25
	pop r24
	pop r19
	pop r15
	pop r14
	rjmp show_nib_x

spi_ev_miso: ldi ZL,LOW(spi_msk_miso*2)
	ldi ZH,HIGH(spi_msk_miso*2)
	rjmp spi_ev_line
spi_ev_mosi: ldi ZL,LOW(spi_msk_mosi*2)
	ldi ZH,HIGH(spi_msk_mosi*2)
spi_ev_line: sbrs r20,0
	adiw ZH:ZL,3
	lpm r4,Z+	;data line
	lpm r5,Z+	;clock line
	lpm r6,Z	;ss line

	ldi YL,LOW(trace)
	ldi YH,HIGH(trace)
	lds ZL,trace_offset
	lds ZH,trace_offset+1
	ldi XL,LOW(trace+trace_size-1)
	ldi XH,HIGH(trace+trace_size-1)
	clr r8
	sbis tr_mode,1
	rjmp spi_ev_line1
	sbiw XH:XL,1
	add ZL,ZL
	adc ZH,ZH
	add YL,r15
	adc YH,r8
spi_ev_line1:
	mov r13,XL
	mov r7,XH
	add ZL,YL
	add ZH,YH
	ldi XL,LOW(line)
	ldi XH,HIGH(line)
spi_ev_linelp:
	cp YL,r13
	cpc YH,r7
	brcc spi_ev_linex
	ld r16,Y
	and r16,r6
	brne spi_ev_linenxt
	ld r16,Y
	eor r16,r9
	and r16,r5
	brne spi_ev_linenxt
	ldd r16,Y+1
	sbic tr_mode,1
	ldd r16,Y+2
	eor r16,r9
	and r16,r5
	breq spi_ev_linenxt
	movw r1:r0,YH:YL
	rcall spi_get_byte
	brcc spi_ev_linex
	brne spi_ev_linenxt
	cp YL,ZL
	cpc YH,ZH
	brcs spi_ev_linenxt
	ldi r17,1
	sbic tr_mode,1
	inc r17
	add r0,r17
	adc r1,r8
	st X+,r1
	st X+,r0
	movw r3:r2,YH:YL
	add r2,r17
	adc r3,r8
	sub r2,r0
	sbc r3,r1
	sbic tr_mode,1
	lsr r3
	sbic tr_mode,1
	ror r2
	st X+,r2
	st X+,r3
	st X+,r16
	ldi r16,HIGH(line+251)
	cpi XL,LOW(line+251)
	cpc XH,r16
	brcc spi_ev_linex
spi_ev_linenxt: adiw YH:YL,1
	sbic tr_mode,1
	adiw YH:YL,1
	rjmp spi_ev_linelp
spi_ev_linex: ldi r16,$7f
	st X,r16
	clr r4
	clr r5
	lds r16,line
	cpi r16,$7f
	breq spi_ev_linex1
	lds r4,line+2
	lds r16,line+3
	andi r16,$3f
	mov r5,r16
	call get_tscale
	tst r16
	brmi spi_ev_linex1
	movw r3:r2,r5:r4
	mul r2,r16
	movw r5:r4,r1:r0
	mul r3,r16
	add r5,r0
spi_ev_linex1: sts ser_offset,r4
	sts ser_offset+1,r5
	ret

spi_get_byte:
	ldi r17,8
spi_get_bytelp: ldd r16,Y+1
	sbic tr_mode,1
	ldd r16,Y+2
	mov r2,r16
	and r2,r6
	brne spi_get_bytexf
	ld r2,Y
	eor r2,r9
	and r2,r5
	brne spi_get_bytenxt
	mov r2,r16
	eor r2,r9
	and r2,r5
	breq spi_get_bytenxt
	clc
	and r16,r4
	breq spi_get_byte1
	sec
spi_get_byte1:
	sbrs r10,0
	rol r3
	sbrc r10,0
	ror r3
	dec r17
	breq spi_get_bytex
spi_get_bytenxt: adiw YH:YL,1
	sbic tr_mode,1
	adiw YH:YL,1
	cp YL,r13
	cpc YH,r7
	brcs spi_get_bytelp
	ret
spi_get_bytex: mov r16,r3
	sec
	ret
spi_get_bytexf: sec
	ret

spi_msk_mosi: .db 1,4,8,16,64,128
spi_msk_miso: .db 2,4,8,32,64,128

show_i2c:
	rcall i2c_ev_line
	push r14
	push r15
	push r19
	push r24
	push r25
	clr r11
	rcall show_ser
	pop r25
	pop r24
	pop r19
	pop r15
	pop r14
	subi r21,-10
	lsl r20
	ldi r16,2
	add r14,r16
	ret

i2c_ev_line:
	mov r4,r20		;SDA
	lsl r4			;SCL
	ldi r16,5
	mov r6,r16
	ldi r16,$40
	mov r7,r16
	ldi YL,LOW(trace)
	ldi YH,HIGH(trace)
	lds ZL,trace_offset
	lds ZH,trace_offset+1
	ldi XL,LOW(trace+trace_size-1)
	ldi XH,HIGH(trace+trace_size-1)
	ldi r17,5
	clr r8
	sbis tr_mode,1
	rjmp i2c_ev_line1
	add ZL,ZL
	adc ZH,ZH
	add YL,r15
	adc YH,r8
	sbiw XH:XL,1
	ldi r17,10
i2c_ev_line1:
	mov r13,XL
	mov r5,XH
	mov r9,r17
	add ZL,YL
	add ZH,YH
	ldi XL,LOW(line)
	ldi XH,HIGH(line)
i2c_ev_linelp: cp YL,r13
	cpc YH,r5
	brcc i2c_ev_linex_
	ld r16,Y
	and r16,r4
	breq i2c_ev_linenxt
	ldd r0,Y+1
	sbic tr_mode,1
	ldd r0,Y+2
	mov r16,r0
	and r16,r4
	breq i2c_ev_line4
	ld r16,Y
	and r16,r20
	breq i2c_ev_line2
	and r0,r20
	brne i2c_ev_linenxt
	ldi r16,27			;I2C Start
	rjmp i2c_ev_line3
i2c_ev_line2: and r0,r20
	breq i2c_ev_linenxt
	ldi r16,28			;I2C Stop
i2c_ev_line3: movw r3:r2,ZH:ZL
	sub r2,r9
	sbc r3,r8
	cp YL,r2
	cpc YH,r3
	brcs i2c_ev_linenxt
	movw r3:r2,YH:YL
	ldi r17,1
	sbic tr_mode,1
	ldi r17,2
	add r2,r17
	adc r3,r8
	st X+,r3
	st X+,r2
	movw r3:r2,r7:r6
	rjmp i2c_ev_line5
i2c_ev_line4: 
	movw r1:r0,YH:YL
	rcall i2c_get_byte
	breq i2c_ev_linelp
i2c_ev_linex_: brcc i2c_ev_linex
	cp YL,ZL
	cpc YH,ZH
	brcs i2c_ev_linenxt
	ldi r18,1
	sbic tr_mode,1
	ldi r18,2
	add r0,r18
	adc r1,r8
	st X+,r1
	st X+,r0
	movw r3:r2,YH:YL
	add r2,r18
	adc r3,r8
	sub r2,r0
	sbc r3,r1
	sbic tr_mode,1
	lsr r3
	sbic tr_mode,1
	ror r2
	or r3,r17
i2c_ev_line5: st X+,r2
	st X+,r3
	st X+,r16
	ldi r16,HIGH(line+251)
	cpi XL,LOW(line+251)
	cpc XH,r16
	brcc i2c_ev_linex
i2c_ev_linenxt: adiw YH:YL,1
	sbic tr_mode,1
	adiw YH:YL,1
	rjmp i2c_ev_linelp
i2c_ev_linex: rjmp spi_ev_linex

i2c_get_byte:
	ldi r17,8
i2c_get_bytelp:
	ldd r2,Y+1
	sbic tr_mode,1
	ldd r2,Y+2
	ld r16,Y
	and r16,r4
	breq i2c_get_byte0
	mov r16,r2
	and r16,r4
	breq i2c_get_bytenxt
	ld r16,Y
	and r16,r20
	and r2,r20
	eor r16,r2
	breq i2c_get_bytenxt
	clc
	sez
	ret
i2c_get_byte0: mov r16,r2
	and r16,r4
	breq i2c_get_bytenxt
	and r2,r20
	clc
	breq i2c_get_byte1
	sec
i2c_get_byte1: tst r17
	brne i2c_get_byte2
	ror r17
	rjmp i2c_get_bytex
i2c_get_byte2: rol r3
	dec r17
i2c_get_bytenxt: adiw YH:YL,1
	sbic tr_mode,1
	adiw YH:YL,1
	cp YL,r13
	cpc YH,r5
	brcs i2c_get_bytelp
	clz
	ret
i2c_get_bytex: mov r16,r3
	clz
	sec
	ret
